/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern0 (x3, 
E_V4SImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 1;

    case E_V1TImode:
      if (pattern0 (x3, 
E_V1TImode) != 0)
        return -1;
      return 2;

    case E_TImode:
      if (pattern0 (x3, 
E_TImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (XVECLEN (x2, 0) != 2
      || XINT (x2, 1) != 19)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != IF_THEN_ELSE)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 2);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != PC)
    return -1;
  return 0;
}

int
pattern18 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern24 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || GET_MODE (x3) != E_V1TImode
          || !register_operand (operands[1], E_V1TImode))
        return -1;
      return 4;

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x3) != E_TImode
          || !register_operand (operands[1], E_TImode))
        return -1;
      return 5;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 6;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 7;

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x3) != E_V1TFmode
          || !register_operand (operands[1], E_V1TFmode))
        return -1;
      return 8;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern43 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 33
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[1] = x8;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x9 = XEXP (x4, 0);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x10 = XEXP (x3, 0);
  if (!rtx_equal_p (x10, operands[0]))
    return -1;
  return 0;
}

int
pattern51 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern57 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i2))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!const_mask_operand (operands[2], E_QImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_mask_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern61 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[3], i1)
      || !contiguous_bitmask_nowrap_operand (operands[2], i1)
      || !nonimmediate_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern69 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_TDmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_TDmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TFmode:
          return 0;

        case E_FPRX2mode:
          return 1;

        case E_DFmode:
          return 2;

        case E_SFmode:
          return 3;

        default:
          return -1;
        }

    case E_DDmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DDmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TFmode:
          return 4;

        case E_FPRX2mode:
          return 5;

        case E_DFmode:
          return 6;

        case E_SFmode:
          return 7;

        default:
          return -1;
        }

    case E_SDmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SDmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TFmode:
          return 8;

        case E_FPRX2mode:
          return 9;

        case E_DFmode:
          return 10;

        case E_SFmode:
          return 11;

        default:
          return -1;
        }

    case E_TFmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_TFmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TDmode:
          return 12;

        case E_DDmode:
          return 13;

        case E_SDmode:
          return 14;

        default:
          return -1;
        }

    case E_FPRX2mode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_FPRX2mode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TDmode:
          return 15;

        case E_DDmode:
          return 16;

        case E_SDmode:
          return 17;

        default:
          return -1;
        }

    case E_DFmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DFmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TDmode:
          return 18;

        case E_DDmode:
          return 19;

        case E_SDmode:
          return 20;

        default:
          return -1;
        }

    case E_SFmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TDmode:
          return 21;

        case E_DDmode:
          return 22;

        case E_SDmode:
          return 23;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern108 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern114 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (XVECLEN (x3, 0))
    {
    case 8:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XVECEXP (x3, 0, 4);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XVECEXP (x3, 0, 5);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x11 = XVECEXP (x3, 0, 6);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x12 = XVECEXP (x3, 0, 7);
      if (GET_CODE (x12) != CONST_INT
          || !register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 0L:
          if (XWINT (x6, 0) != 1L
              || XWINT (x7, 0) != 2L
              || XWINT (x8, 0) != 3L
              || XWINT (x9, 0) != 4L
              || XWINT (x10, 0) != 5L
              || XWINT (x11, 0) != 6L
              || XWINT (x12, 0) != 7L)
            return -1;
          return 0;

        case 8L:
          if (XWINT (x6, 0) != 9L
              || XWINT (x7, 0) != 10L
              || XWINT (x8, 0) != 11L
              || XWINT (x9, 0) != 12L
              || XWINT (x10, 0) != 13L
              || XWINT (x11, 0) != 14L
              || XWINT (x12, 0) != 15L)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 4:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != CONST_INT
          || !register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 0L:
          if (XWINT (x6, 0) != 1L
              || XWINT (x7, 0) != 2L
              || XWINT (x8, 0) != 3L)
            return -1;
          return 2;

        case 4L:
          if (XWINT (x6, 0) != 5L
              || XWINT (x7, 0) != 6L
              || XWINT (x8, 0) != 7L)
            return -1;
          return 3;

        default:
          return -1;
        }

    case 2:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 0L:
          if (XWINT (x6, 0) != 1L)
            return -1;
          return 4;

        case 2L:
          if (XWINT (x6, 0) != 3L)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern154 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_DImode)
          || !general_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !general_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern162 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 1);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[2] = x7;
      x8 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x8))
        {
        case SET:
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != i1)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != NOT)
            return -1;
          x11 = XEXP (x8, 0);
          operands[0] = x11;
          x12 = XEXP (x10, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          x13 = XEXP (x9, 1);
          if (!rtx_equal_p (x13, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              return pattern158 (x1, 
E_DImode); /* [-1, 0] */

            case E_SImode:
              if (pattern158 (x1, 
E_SImode) != 0)
                return -1;
              return 1;

            default:
              return -1;
            }

        case CLOBBER:
          x11 = XEXP (x8, 0);
          operands[0] = x11;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern159 (x5, 
E_DImode) != 0)
                return -1;
              return 2;

            case E_SImode:
              if (pattern159 (x5, 
E_SImode) != 0)
                return -1;
              return 3;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x14 = XEXP (x7, 0);
      operands[2] = x14;
      x8 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x8))
        {
        case SET:
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != i1)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != NOT)
            return -1;
          x13 = XEXP (x9, 1);
          if (GET_CODE (x13) != NOT)
            return -1;
          x11 = XEXP (x8, 0);
          operands[0] = x11;
          x12 = XEXP (x10, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          x15 = XEXP (x13, 0);
          if (!rtx_equal_p (x15, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern160 (x1, 
E_DImode) != 0)
                return -1;
              return 4;

            case E_SImode:
              if (pattern160 (x1, 
E_SImode) != 0)
                return -1;
              return 5;

            default:
              return -1;
            }

        case CLOBBER:
          x11 = XEXP (x8, 0);
          operands[0] = x11;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern161 (x4, 
E_DImode) != 0)
                return -1;
              return 6;

            case E_SImode:
              if (pattern161 (x4, 
E_SImode) != 0)
                return -1;
              return 7;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern205 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i1)
      || !const0_operand (operands[4], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern214 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern225 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != MINUS)
        return -1;
      return 0;

    case CLOBBER:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XVECEXP (x1, 0, 0);
      x6 = XEXP (x5, 1);
      x7 = XEXP (x6, 0);
      switch (GET_MODE (x7))
        {
        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !general_operand (operands[2], E_DImode)
              || !scratch_operand (operands[0], E_DImode))
            return -1;
          return 1;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !general_operand (operands[2], E_SImode)
              || !scratch_operand (operands[0], E_SImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern244 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x4, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XVECEXP (x1, 0, 0);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  switch (GET_MODE (x9))
    {
    case E_DImode:
      return pattern243 (x4, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern243 (x4, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern258 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern269 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  switch (XWINT (x3, 0))
    {
    case 1L:
      x4 = XEXP (x1, 1);
      if (XWINT (x4, 0) != 8589934590L)
        return -1;
      return 0;

    case 2L:
      x4 = XEXP (x1, 1);
      if (XWINT (x4, 0) != 17179869180L)
        return -1;
      return 1;

    case 3L:
      x4 = XEXP (x1, 1);
      if (XWINT (x4, 0) != 34359738360L)
        return -1;
      return 2;

    case 4L:
      x4 = XEXP (x1, 1);
      if (XWINT (x4, 0) != 68719476720L)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern281 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern289 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern297 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 5);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i5
      || GET_MODE (x5) != i2)
    return -1;
  x6 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i4
      || GET_MODE (x7) != i2)
    return -1;
  x8 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != i3
      || GET_MODE (x9) != i2)
    return -1;
  x10 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i1)
    return -1;
  return 0;
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern28 (x1))
    {
    case 0:
      if (!
#line 1868 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1225; /* vec_widen_umult_odd_v1qi */

    case 1:
      if (!
#line 1868 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1226; /* vec_widen_umult_odd_v2qi */

    case 2:
      if (!
#line 1868 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1227; /* vec_widen_umult_odd_v4qi */

    case 3:
      if (!
#line 1868 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1228; /* vec_widen_umult_odd_v8qi */

    case 4:
      if (!
#line 1868 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1229; /* vec_widen_umult_odd_v16qi */

    case 5:
      if (!
#line 1868 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1230; /* vec_widen_umult_odd_v1hi */

    case 6:
      if (!
#line 1868 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1231; /* vec_widen_umult_odd_v2hi */

    case 7:
      if (!
#line 1868 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1232; /* vec_widen_umult_odd_v4hi */

    case 8:
      if (!
#line 1868 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1233; /* vec_widen_umult_odd_v8hi */

    case 9:
      if (!
#line 1868 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1234; /* vec_widen_umult_odd_v1si */

    case 10:
      if (!
#line 1868 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1235; /* vec_widen_umult_odd_v2si */

    case 11:
      if (!
#line 1868 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1236; /* vec_widen_umult_odd_v4si */

    case 12:
      if (!
#line 1868 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1237; /* vec_widen_umult_odd_v1di */

    case 13:
      if (!(
#line 1868 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 71 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return -1;
      return 1238; /* vec_widen_umult_odd_v2di */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  operands[3] = x3;
  x4 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x4))
    {
    case BSWAP:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern184 (x2, 
E_V8HImode, 
E_HImode) != 0
              || !
#line 2169 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
            return -1;
          return 481; /* *vec_set_bswap_elemv8hi */

        case E_V4SImode:
          if (pattern184 (x2, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 2169 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 482; /* *vec_set_bswap_elemv4si */

        case E_V4SFmode:
          if (pattern184 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !(
#line 2169 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 44 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 483; /* *vec_set_bswap_elemv4sf */

        case E_V2DImode:
          if (pattern184 (x2, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 2169 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 484; /* *vec_set_bswap_elemv2di */

        case E_V2DFmode:
          if (pattern184 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 2169 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 485; /* *vec_set_bswap_elemv2df */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      x6 = XVECEXP (x2, 0, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x6;
          if (!nonmemory_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V1QImode:
              if (pattern198 (x2, 
E_V1QImode, 
E_QImode) != 0
                  || !
#line 529 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1QImode))))
                return -1;
              return 543; /* *vec_setv1qi */

            case E_V2QImode:
              if (pattern198 (x2, 
E_V2QImode, 
E_QImode) != 0
                  || !
#line 529 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2QImode))))
                return -1;
              return 544; /* *vec_setv2qi */

            case E_V4QImode:
              if (pattern198 (x2, 
E_V4QImode, 
E_QImode) != 0
                  || !
#line 529 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V4QImode))))
                return -1;
              return 545; /* *vec_setv4qi */

            case E_V8QImode:
              if (pattern198 (x2, 
E_V8QImode, 
E_QImode) != 0
                  || !
#line 529 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V8QImode))))
                return -1;
              return 546; /* *vec_setv8qi */

            case E_V16QImode:
              if (pattern198 (x2, 
E_V16QImode, 
E_QImode) != 0
                  || !
#line 529 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V16QImode))))
                return -1;
              return 547; /* *vec_setv16qi */

            case E_V1HImode:
              if (pattern198 (x2, 
E_V1HImode, 
E_HImode) != 0
                  || !
#line 529 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1HImode))))
                return -1;
              return 548; /* *vec_setv1hi */

            case E_V2HImode:
              if (pattern198 (x2, 
E_V2HImode, 
E_HImode) != 0
                  || !
#line 529 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2HImode))))
                return -1;
              return 549; /* *vec_setv2hi */

            case E_V4HImode:
              if (pattern198 (x2, 
E_V4HImode, 
E_HImode) != 0
                  || !
#line 529 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V4HImode))))
                return -1;
              return 550; /* *vec_setv4hi */

            case E_V8HImode:
              if (pattern198 (x2, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 529 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode))))
                return -1;
              return 551; /* *vec_setv8hi */

            case E_V1SImode:
              if (pattern198 (x2, 
E_V1SImode, 
E_SImode) != 0
                  || !
#line 529 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1SImode))))
                return -1;
              return 552; /* *vec_setv1si */

            case E_V2SImode:
              if (pattern198 (x2, 
E_V2SImode, 
E_SImode) != 0
                  || !
#line 529 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2SImode))))
                return -1;
              return 553; /* *vec_setv2si */

            case E_V4SImode:
              if (pattern198 (x2, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 529 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode))))
                return -1;
              return 554; /* *vec_setv4si */

            case E_V1DImode:
              if (pattern198 (x2, 
E_V1DImode, 
E_DImode) != 0
                  || !
#line 529 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1DImode))))
                return -1;
              return 555; /* *vec_setv1di */

            case E_V2DImode:
              if (pattern198 (x2, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 529 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode))))
                return -1;
              return 556; /* *vec_setv2di */

            case E_V2SFmode:
              if (pattern198 (x2, 
E_V2SFmode, 
E_SFmode) != 0
                  || !
#line 529 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2SFmode))))
                return -1;
              return 557; /* *vec_setv2sf */

            case E_V4SFmode:
              if (pattern198 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 529 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode))))
                return -1;
              return 558; /* *vec_setv4sf */

            case E_V1SFmode:
              if (pattern198 (x2, 
E_V1SFmode, 
E_SFmode) != 0
                  || !
#line 545 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 559; /* *vec_setv1sf */

            case E_V1DFmode:
              if (pattern198 (x2, 
E_V1DFmode, 
E_DFmode) != 0
                  || !
#line 545 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 560; /* *vec_setv1df */

            case E_V1TFmode:
              if (pattern198 (x2, 
E_V1TFmode, 
E_TFmode) != 0
                  || !(
#line 545 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 515 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 561; /* *vec_setv1tf */

            case E_V2DFmode:
              if (pattern198 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 557 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode))))
                return -1;
              return 562; /* *vec_setv2df */

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[4] = x8;
          if (!const_int_operand (operands[4], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V1QImode:
              if (pattern198 (x2, 
E_V1QImode, 
E_QImode) != 0
                  || !
#line 602 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 563; /* *vec_setv1qi_plus */

            case E_V2QImode:
              if (pattern198 (x2, 
E_V2QImode, 
E_QImode) != 0
                  || !
#line 602 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 564; /* *vec_setv2qi_plus */

            case E_V4QImode:
              if (pattern198 (x2, 
E_V4QImode, 
E_QImode) != 0
                  || !
#line 602 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 565; /* *vec_setv4qi_plus */

            case E_V8QImode:
              if (pattern198 (x2, 
E_V8QImode, 
E_QImode) != 0
                  || !
#line 602 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 566; /* *vec_setv8qi_plus */

            case E_V16QImode:
              if (pattern198 (x2, 
E_V16QImode, 
E_QImode) != 0
                  || !
#line 602 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 567; /* *vec_setv16qi_plus */

            case E_V1HImode:
              if (pattern198 (x2, 
E_V1HImode, 
E_HImode) != 0
                  || !
#line 602 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 568; /* *vec_setv1hi_plus */

            case E_V2HImode:
              if (pattern198 (x2, 
E_V2HImode, 
E_HImode) != 0
                  || !
#line 602 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 569; /* *vec_setv2hi_plus */

            case E_V4HImode:
              if (pattern198 (x2, 
E_V4HImode, 
E_HImode) != 0
                  || !
#line 602 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 570; /* *vec_setv4hi_plus */

            case E_V8HImode:
              if (pattern198 (x2, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 602 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 571; /* *vec_setv8hi_plus */

            case E_V1SImode:
              if (pattern198 (x2, 
E_V1SImode, 
E_SImode) != 0
                  || !
#line 602 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 572; /* *vec_setv1si_plus */

            case E_V2SImode:
              if (pattern198 (x2, 
E_V2SImode, 
E_SImode) != 0
                  || !
#line 602 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 573; /* *vec_setv2si_plus */

            case E_V4SImode:
              if (pattern198 (x2, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 602 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 574; /* *vec_setv4si_plus */

            case E_V1DImode:
              if (pattern198 (x2, 
E_V1DImode, 
E_DImode) != 0
                  || !
#line 602 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 575; /* *vec_setv1di_plus */

            case E_V2DImode:
              if (pattern198 (x2, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 602 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 576; /* *vec_setv2di_plus */

            case E_V1SFmode:
              if (pattern198 (x2, 
E_V1SFmode, 
E_SFmode) != 0
                  || !
#line 602 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 577; /* *vec_setv1sf_plus */

            case E_V2SFmode:
              if (pattern198 (x2, 
E_V2SFmode, 
E_SFmode) != 0
                  || !
#line 602 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 578; /* *vec_setv2sf_plus */

            case E_V4SFmode:
              if (pattern198 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 602 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 579; /* *vec_setv4sf_plus */

            case E_V1DFmode:
              if (pattern198 (x2, 
E_V1DFmode, 
E_DFmode) != 0
                  || !
#line 602 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 580; /* *vec_setv1df_plus */

            case E_V2DFmode:
              if (pattern198 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 602 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 581; /* *vec_setv2df_plus */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == EQ)
    {
      res = recog_30 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[0] = x3;
  if (!s390_signed_integer_comparison (operands[0], E_VOIDmode))
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  x7 = XEXP (x2, 1);
  if (GET_CODE (x7) == PC)
    {
      x8 = XEXP (x2, 2);
      switch (pattern173 (x8))
        {
        case 0:
          if ((
#line 1702 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            {
              *pnum_clobbers = 1;
              return 1823; /* *icmp_and_br_signed_di */
            }
          break;

        case 1:
          if (
#line 1702 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            {
              *pnum_clobbers = 1;
              return 1824; /* *icmp_and_br_signed_si */
            }
          break;

        default:
          break;
        }
    }
  if (GET_CODE (x7) != LABEL_REF)
    return -1;
  switch (pattern172 (x2))
    {
    case 0:
      if (!(
#line 1644 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      *pnum_clobbers = 1;
      return 1819; /* *cmp_and_br_signed_di */

    case 1:
      if (!
#line 1644 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
        return -1;
      *pnum_clobbers = 1;
      return 1820; /* *cmp_and_br_signed_si */

    default:
      return -1;
    }
}

 int
recog_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (!s390_unsigned_integer_comparison (x3, E_VOIDmode))
    return -1;
  operands[0] = x3;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  x7 = XEXP (x2, 1);
  switch (GET_CODE (x7))
    {
    case LABEL_REF:
      switch (pattern172 (x2))
        {
        case 0:
          if (!(
#line 1672 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1821; /* *cmp_and_br_unsigned_di */

        case 1:
          if (!
#line 1672 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return -1;
          *pnum_clobbers = 1;
          return 1822; /* *cmp_and_br_unsigned_si */

        default:
          return -1;
        }

    case PC:
      x8 = XEXP (x2, 2);
      switch (pattern173 (x8))
        {
        case 0:
          if (!(
#line 1730 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1825; /* *icmp_and_br_unsigned_di */

        case 1:
          if (!
#line 1730 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return -1;
          *pnum_clobbers = 1;
          return 1826; /* *icmp_and_br_unsigned_si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      if ((
#line 4320 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (DImode))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return 1938; /* *extzvdi_nocc */
      if (pnum_clobbers == NULL
          || !(
#line 4320 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (DImode))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      *pnum_clobbers = 1;
      return 1939; /* *extzvdi_clobbercc */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      if (
#line 4320 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (SImode))))
        return 1940; /* *extzvsi_nocc */
      if (pnum_clobbers == NULL
          || !
#line 4320 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (SImode))))
        return -1;
      *pnum_clobbers = 1;
      return 1941; /* *extzvsi_clobbercc */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTRACT:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x8 = XEXP (x5, 2);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      if (
#line 4367 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (1, INTVAL (operands[2]), 64)))
        return 1948; /* *extract1bitdi_nocc */
      if (pnum_clobbers == NULL
          || !
#line 4367 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (1, INTVAL (operands[2]), 64)))
        return -1;
      *pnum_clobbers = 1;
      return 1949; /* *extract1bitdi_clobbercc */

    case REG:
    case SUBREG:
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x5;
      if (!register_operand (operands[1], E_CCZ1mode)
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      *pnum_clobbers = 1;
      return 2320; /* sne */

    default:
      return -1;
    }
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NOT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern174 (x2, 
E_V16QImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 118; /* vec_andcv16qi3 */

        case E_V8HImode:
          if (pattern174 (x2, 
E_V8HImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 119; /* vec_andcv8hi3 */

        case E_V4SImode:
          if (pattern174 (x2, 
E_V4SImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 120; /* vec_andcv4si3 */

        case E_V2DImode:
          if (pattern174 (x2, 
E_V2DImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 121; /* vec_andcv2di3 */

        case E_V2DFmode:
          if (pattern174 (x2, 
E_V2DFmode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 122; /* vec_andcv2df3 */

        case E_V1TImode:
          if (pattern174 (x2, 
E_V1TImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 123; /* vec_andcv1ti3 */

        case E_TImode:
          if (pattern174 (x2, 
E_TImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 124; /* vec_andcti3 */

        case E_V4SFmode:
          if (pattern174 (x2, 
E_V4SFmode) != 0
              || !(
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 47 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 125; /* vec_andcv4sf3 */

        case E_V1TFmode:
          if (pattern174 (x2, 
E_V1TFmode) != 0
              || !(
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 47 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 126; /* vec_andcv1tf3 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      x4 = XEXP (x1, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x4;
          operands[1] = x3;
          x6 = XEXP (x2, 1);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V1QImode:
              if (pattern0 (x2, 
E_V1QImode) != 0
                  || !
#line 1377 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 784; /* andv1qi3 */

            case E_V2QImode:
              if (pattern0 (x2, 
E_V2QImode) != 0
                  || !
#line 1377 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 785; /* andv2qi3 */

            case E_V4QImode:
              if (pattern0 (x2, 
E_V4QImode) != 0
                  || !
#line 1377 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 786; /* andv4qi3 */

            case E_V8QImode:
              if (pattern0 (x2, 
E_V8QImode) != 0
                  || !
#line 1377 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 787; /* andv8qi3 */

            case E_V16QImode:
              if (pattern0 (x2, 
E_V16QImode) != 0
                  || !
#line 1377 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 788; /* andv16qi3 */

            case E_V1HImode:
              if (pattern0 (x2, 
E_V1HImode) != 0
                  || !
#line 1377 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 789; /* andv1hi3 */

            case E_V2HImode:
              if (pattern0 (x2, 
E_V2HImode) != 0
                  || !
#line 1377 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 790; /* andv2hi3 */

            case E_V4HImode:
              if (pattern0 (x2, 
E_V4HImode) != 0
                  || !
#line 1377 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 791; /* andv4hi3 */

            case E_V8HImode:
              if (pattern0 (x2, 
E_V8HImode) != 0
                  || !
#line 1377 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 792; /* andv8hi3 */

            case E_V1SImode:
              if (pattern0 (x2, 
E_V1SImode) != 0
                  || !
#line 1377 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 793; /* andv1si3 */

            case E_V2SImode:
              if (pattern0 (x2, 
E_V2SImode) != 0
                  || !
#line 1377 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 794; /* andv2si3 */

            case E_V4SImode:
              if (pattern0 (x2, 
E_V4SImode) != 0
                  || !
#line 1377 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 795; /* andv4si3 */

            case E_V1DImode:
              if (pattern0 (x2, 
E_V1DImode) != 0
                  || !
#line 1377 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 796; /* andv1di3 */

            case E_V2DImode:
              if (pattern0 (x2, 
E_V2DImode) != 0
                  || !
#line 1377 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 797; /* andv2di3 */

            case E_V1SFmode:
              if (pattern0 (x2, 
E_V1SFmode) != 0
                  || !
#line 1377 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 798; /* andv1sf3 */

            case E_V2SFmode:
              if (pattern0 (x2, 
E_V2SFmode) != 0
                  || !
#line 1377 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 799; /* andv2sf3 */

            case E_V4SFmode:
              if (pattern0 (x2, 
E_V4SFmode) != 0
                  || !
#line 1377 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 800; /* andv4sf3 */

            case E_V1DFmode:
              if (pattern0 (x2, 
E_V1DFmode) != 0
                  || !
#line 1377 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 801; /* andv1df3 */

            case E_V2DFmode:
              if (pattern0 (x2, 
E_V2DFmode) != 0
                  || !
#line 1377 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 802; /* andv2df3 */

            case E_V1TFmode:
              if (pattern0 (x2, 
E_V1TFmode) != 0
                  || !
#line 1377 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 803; /* andv1tf3 */

            case E_V1TImode:
              if (pattern0 (x2, 
E_V1TImode) != 0
                  || !
#line 1377 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 804; /* andv1ti3 */

            case E_TImode:
              if (pattern0 (x2, 
E_TImode) != 0
                  || !
#line 1377 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 805; /* andti3 */

            case E_HImode:
              if (pnum_clobbers == NULL
                  || pattern64 (x2, 
E_HImode) != 0)
                return -1;
              if (
#line 8153 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
                {
                  *pnum_clobbers = 1;
                  return 2373; /* *andhi3_zarch */
                }
              if (!
#line 8170 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
                return -1;
              *pnum_clobbers = 1;
              return 2374; /* *andhi3_esa */

            case E_QImode:
              if (pnum_clobbers == NULL
                  || pattern64 (x2, 
E_QImode) != 0)
                return -1;
              if (
#line 8198 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
                {
                  *pnum_clobbers = 1;
                  return 2375; /* *andqi3_zarch */
                }
              if (!
#line 8215 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
                return -1;
              *pnum_clobbers = 1;
              return 2376; /* *andqi3_esa */

            default:
              return -1;
            }

        case ZERO_EXTRACT:
          if (pnum_clobbers == NULL
              || pattern141 (x1) != 0)
            return -1;
          x6 = XEXP (x2, 1);
          operands[3] = x6;
          if (!nonimmediate_operand (operands[3], E_DImode)
              || !rtx_equal_p (x3, operands[0])
              || !
#line 4833 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && INTVAL (operands[1]) + INTVAL (operands[2]) == 64))
            return -1;
          *pnum_clobbers = 1;
          return 2016; /* *insv_rnsbg_noshift */

        default:
          return -1;
        }

    case GE:
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != GE)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      x8 = XEXP (x6, 0);
      if (!rtx_equal_p (x8, operands[2]))
        return -1;
      x9 = XEXP (x6, 1);
      if (!rtx_equal_p (x9, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V1SImode:
          if (pattern221 (x2, 
E_V1SImode, 
E_V1SFmode) != 0
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1387; /* *vec_cmpeqv1sf_signaling_nocc */

        case E_V2SImode:
          if (pattern221 (x2, 
E_V2SImode, 
E_V2SFmode) != 0
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1388; /* *vec_cmpeqv2sf_signaling_nocc */

        case E_V4SImode:
          if (pattern221 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1389; /* *vec_cmpeqv4sf_signaling_nocc */

        case E_V1DImode:
          if (pattern221 (x2, 
E_V1DImode, 
E_V1DFmode) != 0
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1390; /* *vec_cmpeqv1df_signaling_nocc */

        case E_V2DImode:
          if (pattern221 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1391; /* *vec_cmpeqv2df_signaling_nocc */

        case E_V1TImode:
          if (pattern221 (x2, 
E_V1TImode, 
E_V1TFmode) != 0
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1392; /* *vec_cmpeqv1tf_signaling_nocc */

        case E_TImode:
          if (pattern221 (x2, 
E_TImode, 
E_TFmode) != 0
              || !
#line 2411 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1393; /* *vec_cmpeqtf_signaling_nocc */

        default:
          return -1;
        }

    case AND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern29 (x2))
        {
        case 0:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1591; /* *vevalv1qi_andand */

        case 1:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1600; /* *vevalv2qi_andand */

        case 2:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1609; /* *vevalv4qi_andand */

        case 3:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1618; /* *vevalv8qi_andand */

        case 4:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1627; /* *vevalv16qi_andand */

        case 5:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1636; /* *vevalv1hi_andand */

        case 6:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1645; /* *vevalv2hi_andand */

        case 7:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1654; /* *vevalv4hi_andand */

        case 8:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1663; /* *vevalv8hi_andand */

        case 9:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1672; /* *vevalv1si_andand */

        case 10:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1681; /* *vevalv2si_andand */

        case 11:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1690; /* *vevalv4si_andand */

        case 12:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1699; /* *vevalv1di_andand */

        case 13:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1708; /* *vevalv2di_andand */

        case 14:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1717; /* *vevalv1ti_andand */

        case 15:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1726; /* *vevalti_andand */

        default:
          return -1;
        }

    case IOR:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern29 (x2))
        {
        case 0:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1592; /* *vevalv1qi_andior */

        case 1:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1601; /* *vevalv2qi_andior */

        case 2:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1610; /* *vevalv4qi_andior */

        case 3:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1619; /* *vevalv8qi_andior */

        case 4:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1628; /* *vevalv16qi_andior */

        case 5:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1637; /* *vevalv1hi_andior */

        case 6:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1646; /* *vevalv2hi_andior */

        case 7:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1655; /* *vevalv4hi_andior */

        case 8:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1664; /* *vevalv8hi_andior */

        case 9:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1673; /* *vevalv1si_andior */

        case 10:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1682; /* *vevalv2si_andior */

        case 11:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1691; /* *vevalv4si_andior */

        case 12:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1700; /* *vevalv1di_andior */

        case 13:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1709; /* *vevalv2di_andior */

        case 14:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1718; /* *vevalv1ti_andior */

        case 15:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1727; /* *vevalti_andior */

        default:
          return -1;
        }

    case XOR:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern29 (x2))
        {
        case 0:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1593; /* *vevalv1qi_andxor */

        case 1:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1602; /* *vevalv2qi_andxor */

        case 2:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1611; /* *vevalv4qi_andxor */

        case 3:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1620; /* *vevalv8qi_andxor */

        case 4:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1629; /* *vevalv16qi_andxor */

        case 5:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1638; /* *vevalv1hi_andxor */

        case 6:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1647; /* *vevalv2hi_andxor */

        case 7:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1656; /* *vevalv4hi_andxor */

        case 8:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1665; /* *vevalv8hi_andxor */

        case 9:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1674; /* *vevalv1si_andxor */

        case 10:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1683; /* *vevalv2si_andxor */

        case 11:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1692; /* *vevalv4si_andxor */

        case 12:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1701; /* *vevalv1di_andxor */

        case 13:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1710; /* *vevalv2di_andxor */

        case 14:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1719; /* *vevalv1ti_andxor */

        case 15:
          if (!
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1728; /* *vevalti_andxor */

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != SUBREG
          || maybe_ne (SUBREG_BYTE (x5), 0)
          || GET_MODE (x5) != E_DImode)
        return -1;
      x10 = XEXP (x5, 0);
      if (GET_CODE (x10) != PLUS
          || GET_MODE (x10) != E_SImode)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[1] = x11;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[2] = x12;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (XWINT (x7, 0))
        {
        case 1L:
          if (XWINT (x6, 0) != 8589934590L
              || !
#line 2123 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1847; /* *llxah_displacement_index */

        case 2L:
          if (XWINT (x6, 0) != 17179869180L
              || !
#line 2123 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1848; /* *llxaf_displacement_index */

        case 3L:
          if (XWINT (x6, 0) != 34359738360L
              || !
#line 2123 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1849; /* *llxag_displacement_index */

        case 4L:
          if (XWINT (x6, 0) != 68719476720L
              || !
#line 2123 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1850; /* *llxaq_displacement_index */

        default:
          return -1;
        }

    case LSHIFTRT:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != ZERO_EXTRACT
          || pattern141 (x1) != 0)
        return -1;
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[4] = x6;
      if (!nonimmediate_operand (operands[4], E_DImode))
        return -1;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[0])
          || !
#line 4850 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && INTVAL (operands[3]) == 64 - INTVAL (operands[1]) - INTVAL (operands[2])))
        return -1;
      *pnum_clobbers = 1;
      return 2017; /* *insv_rnsbg_srl */

    default:
      return -1;
    }
}

 int
recog_63 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 4:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 3);
      operands[4] = x4;
      switch (XINT (x2, 1))
        {
        case 61:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!memory_operand (operands[3], E_BLKmode)
              || !const_mask_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern19 (x2, 
E_V4SImode) != 0
                  || !
#line 83 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V4SImode)))
                return -1;
              return 1; /* vec_gather_elementv4si */

            case E_V2DImode:
              if (pattern19 (x2, 
E_V2DImode) != 0
                  || !
#line 83 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V2DImode)))
                return -1;
              return 2; /* vec_gather_elementv2di */

            case E_V2DFmode:
              if (pattern197 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
                  || !
#line 83 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V2DFmode)))
                return -1;
              return 3; /* vec_gather_elementv2df */

            case E_V4SFmode:
              if (pattern197 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
                  || !(
#line 83 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 23 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE)))
                return -1;
              return 4; /* vec_gather_elementv4sf */

            default:
              return -1;
            }

        case 96:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_int_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern51 (x2, 
E_V16QImode) != 0
                  || !
#line 1037 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 203; /* verimv16qi */

            case E_V8HImode:
              if (pattern51 (x2, 
E_V8HImode) != 0
                  || !
#line 1037 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 204; /* verimv8hi */

            case E_V4SImode:
              if (pattern51 (x2, 
E_V4SImode) != 0
                  || !
#line 1037 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 205; /* verimv4si */

            case E_V2DImode:
              if (pattern51 (x2, 
E_V2DImode) != 0
                  || !
#line 1037 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 206; /* verimv2di */

            default:
              return -1;
            }

        case 131:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_V2DImode))
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          if (!register_operand (operands[2], E_V2DImode))
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_mask_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || GET_MODE (x2) != E_V16QImode
                  || !register_operand (operands[3], E_V16QImode)
                  || !
#line 1258 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
                return -1;
              return 357; /* vec_msumv2di */

            case E_TImode:
              if (!register_operand (operands[0], E_TImode)
                  || GET_MODE (x2) != E_TImode
                  || !register_operand (operands[3], E_TImode)
                  || !
#line 1269 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
                return -1;
              return 358; /* vmslg */

            default:
              return -1;
            }

        case 118:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_mask_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern51 (x2, 
E_V16QImode) != 0
                  || !
#line 1541 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 383; /* vstrcv16qi */

            case E_V8HImode:
              if (pattern51 (x2, 
E_V8HImode) != 0
                  || !
#line 1541 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 384; /* vstrcv8hi */

            case E_V4SImode:
              if (pattern51 (x2, 
E_V4SImode) != 0
                  || !
#line 1541 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 385; /* vstrcv4si */

            default:
              return -1;
            }

        case 135:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_int_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V1QImode:
              if (pattern51 (x2, 
E_V1QImode) != 0
                  || !
#line 3564 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1735; /* vevalv1qi */

            case E_V2QImode:
              if (pattern51 (x2, 
E_V2QImode) != 0
                  || !
#line 3564 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1736; /* vevalv2qi */

            case E_V4QImode:
              if (pattern51 (x2, 
E_V4QImode) != 0
                  || !
#line 3564 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1737; /* vevalv4qi */

            case E_V8QImode:
              if (pattern51 (x2, 
E_V8QImode) != 0
                  || !
#line 3564 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1738; /* vevalv8qi */

            case E_V16QImode:
              if (pattern51 (x2, 
E_V16QImode) != 0
                  || !
#line 3564 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1739; /* vevalv16qi */

            case E_V1HImode:
              if (pattern51 (x2, 
E_V1HImode) != 0
                  || !
#line 3564 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1740; /* vevalv1hi */

            case E_V2HImode:
              if (pattern51 (x2, 
E_V2HImode) != 0
                  || !
#line 3564 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1741; /* vevalv2hi */

            case E_V4HImode:
              if (pattern51 (x2, 
E_V4HImode) != 0
                  || !
#line 3564 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1742; /* vevalv4hi */

            case E_V8HImode:
              if (pattern51 (x2, 
E_V8HImode) != 0
                  || !
#line 3564 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1743; /* vevalv8hi */

            case E_V1SImode:
              if (pattern51 (x2, 
E_V1SImode) != 0
                  || !
#line 3564 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1744; /* vevalv1si */

            case E_V2SImode:
              if (pattern51 (x2, 
E_V2SImode) != 0
                  || !
#line 3564 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1745; /* vevalv2si */

            case E_V4SImode:
              if (pattern51 (x2, 
E_V4SImode) != 0
                  || !
#line 3564 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1746; /* vevalv4si */

            case E_V1DImode:
              if (pattern51 (x2, 
E_V1DImode) != 0
                  || !
#line 3564 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1747; /* vevalv1di */

            case E_V2DImode:
              if (pattern51 (x2, 
E_V2DImode) != 0
                  || !
#line 3564 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1748; /* vevalv2di */

            case E_V1TImode:
              if (pattern51 (x2, 
E_V1TImode) != 0
                  || !
#line 3564 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1749; /* vevalv1ti */

            case E_TImode:
              if (pattern51 (x2, 
E_TImode) != 0
                  || !
#line 3564 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1750; /* vevalti */

            default:
              return -1;
            }

        case 31:
          if (pnum_clobbers == NULL)
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_BLKmode)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 0
              || GET_MODE (x7) != E_SImode)
            return -1;
          x5 = XVECEXP (x2, 0, 0);
          operands[2] = x5;
          x8 = XEXP (x6, 0);
          operands[3] = x8;
          if (!immediate_operand (operands[4], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern250 (x2, 
E_DImode) != 0
                  || !
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 1898; /* *strlendi */

            case E_SImode:
              if (pattern250 (x2, 
E_SImode) != 0
                  || !
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 1899; /* *strlensi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      return recog_17 (x1, insn, pnum_clobbers);

    case 2:
      return recog_16 (x1, insn, pnum_clobbers);

    case 3:
      return recog_18 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !(
#line 2037 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1255; /* sqrtv4sf2 */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 2037 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1256; /* sqrtv2df2 */

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x3) != E_V1TFmode
          || !register_operand (operands[1], E_V1TFmode)
          || !(
#line 2037 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1257; /* sqrtv1tf2 */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode)
        return -1;
      if (register_operand (operands[1], E_TFmode)
          && (
#line 2037 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return 1258; /* sqrttf2_vr */
      if (!general_operand (operands[1], E_TFmode)
          || !(
#line 9552 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      return 2513; /* sqrttf2_fpr */

    case E_FPRX2mode:
      if (!register_operand (operands[0], E_FPRX2mode)
          || GET_MODE (x3) != E_FPRX2mode
          || !general_operand (operands[1], E_FPRX2mode)
          || !(
#line 9552 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      return 2514; /* sqrtfprx22 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !general_operand (operands[1], E_DFmode)
          || !
#line 9552 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2515; /* sqrtdf2 */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !general_operand (operands[1], E_SFmode)
          || !
#line 9552 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2516; /* sqrtsf2 */

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 0);
      switch (GET_MODE (x5))
        {
        case E_CCVEQmode:
          x6 = XEXP (x4, 1);
          if (GET_MODE (x6) != E_CCVEQmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || !register_operand (operands[1], E_V16QImode)
                  || !scratch_operand (operands[2], E_V16QImode)
                  || !
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 413; /* *vec_cmpeqv16qi_cconly */

            case E_V8HImode:
              if (!register_operand (operands[0], E_V8HImode)
                  || !register_operand (operands[1], E_V8HImode)
                  || !scratch_operand (operands[2], E_V8HImode)
                  || !
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 416; /* *vec_cmpeqv8hi_cconly */

            case E_V4SImode:
              if (!register_operand (operands[0], E_V4SImode)
                  || !register_operand (operands[1], E_V4SImode)
                  || !scratch_operand (operands[2], E_V4SImode)
                  || !
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 419; /* *vec_cmpeqv4si_cconly */

            case E_V2DImode:
              if (!register_operand (operands[0], E_V2DImode)
                  || !register_operand (operands[1], E_V2DImode)
                  || !scratch_operand (operands[2], E_V2DImode)
                  || !
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 422; /* *vec_cmpeqv2di_cconly */

            case E_V1TImode:
              if (!register_operand (operands[0], E_V1TImode)
                  || !register_operand (operands[1], E_V1TImode)
                  || !scratch_operand (operands[2], E_V1TImode)
                  || !(
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 425; /* *vec_cmpeqv1ti_cconly */

            case E_TImode:
              if (!register_operand (operands[0], E_TImode)
                  || !register_operand (operands[1], E_TImode)
                  || !scratch_operand (operands[2], E_TImode)
                  || !(
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 428; /* *vec_cmpeqti_cconly */

            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || !register_operand (operands[1], E_V4SFmode)
                  || !scratch_operand (operands[2], E_V4SImode)
                  || !(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 449; /* *vec_cmpeqv4sf_cconly */

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || !register_operand (operands[1], E_V2DFmode)
                  || !scratch_operand (operands[2], E_V2DImode)
                  || !
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 450; /* *vec_cmpeqv2df_cconly */

            case E_V1TFmode:
              if (!register_operand (operands[0], E_V1TFmode)
                  || !register_operand (operands[1], E_V1TFmode)
                  || !scratch_operand (operands[2], E_V1TImode)
                  || !(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 451; /* *vec_cmpeqv1tf_cconly */

            case E_TFmode:
              if (!register_operand (operands[0], E_TFmode)
                  || !register_operand (operands[1], E_TFmode)
                  || !scratch_operand (operands[2], E_TImode)
                  || !(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 452; /* *vec_cmpeqtf_cconly */

            default:
              return -1;
            }

        case E_CCVIHmode:
          x6 = XEXP (x4, 1);
          switch (pattern233 (x6, 
E_CCVIHmode))
            {
            case 0:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 414; /* *vec_cmphv16qi_cconly */

            case 1:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 417; /* *vec_cmphv8hi_cconly */

            case 2:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 420; /* *vec_cmphv4si_cconly */

            case 3:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 423; /* *vec_cmphv2di_cconly */

            case 4:
              if (!(
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 426; /* *vec_cmphv1ti_cconly */

            case 5:
              if (!(
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 429; /* *vec_cmphti_cconly */

            default:
              return -1;
            }

        case E_CCVIHUmode:
          x6 = XEXP (x4, 1);
          switch (pattern233 (x6, 
E_CCVIHUmode))
            {
            case 0:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 415; /* *vec_cmphlv16qi_cconly */

            case 1:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 418; /* *vec_cmphlv8hi_cconly */

            case 2:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 421; /* *vec_cmphlv4si_cconly */

            case 3:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 424; /* *vec_cmphlv2di_cconly */

            case 4:
              if (!(
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 427; /* *vec_cmphlv1ti_cconly */

            case 5:
              if (!(
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 430; /* *vec_cmphlti_cconly */

            default:
              return -1;
            }

        case E_CCVFHmode:
          x6 = XEXP (x4, 1);
          switch (pattern234 (x6, 
E_CCVFHmode))
            {
            case 0:
              if (!(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 453; /* *vec_cmphv4sf_cconly */

            case 1:
              if (!
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 454; /* *vec_cmphv2df_cconly */

            case 2:
              if (!(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 455; /* *vec_cmphv1tf_cconly */

            case 3:
              if (!(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 456; /* *vec_cmphtf_cconly */

            default:
              return -1;
            }

        case E_CCVFHEmode:
          x6 = XEXP (x4, 1);
          switch (pattern234 (x6, 
E_CCVFHEmode))
            {
            case 0:
              if (!(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 457; /* *vec_cmphev4sf_cconly */

            case 1:
              if (!
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 458; /* *vec_cmphev2df_cconly */

            case 2:
              if (!(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 459; /* *vec_cmphev1tf_cconly */

            case 3:
              if (!(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 460; /* *vec_cmphetf_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      x7 = XEXP (x2, 1);
      switch (GET_CODE (x7))
        {
        case EQ:
          if (pattern235 (x1, 
E_CCVEQmode) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern272 (x7, 
E_V16QImode) != 0
                  || !
#line 2030 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 431; /* *vec_cmpeqv16qi_cc */

            case E_V8HImode:
              if (pattern272 (x7, 
E_V8HImode) != 0
                  || !
#line 2030 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 432; /* *vec_cmpeqv8hi_cc */

            case E_V4SImode:
              if (pattern272 (x7, 
E_V4SImode) != 0
                  || !
#line 2030 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 433; /* *vec_cmpeqv4si_cc */

            case E_V2DImode:
              if (pattern272 (x7, 
E_V2DImode) != 0
                  || !
#line 2030 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 434; /* *vec_cmpeqv2di_cc */

            case E_V1TImode:
              if (pattern272 (x7, 
E_V1TImode) != 0
                  || !(
#line 2030 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 435; /* *vec_cmpeqv1ti_cc */

            case E_TImode:
              if (pattern272 (x7, 
E_TImode) != 0
                  || !(
#line 2030 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 436; /* *vec_cmpeqti_cc */

            case E_V4SFmode:
              if (pattern273 (x7, 
E_V4SImode, 
E_V4SFmode) != 0
                  || !(
#line 2113 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 461; /* *vec_cmpeqv4sf_cc */

            case E_V2DFmode:
              if (pattern273 (x7, 
E_V2DImode, 
E_V2DFmode) != 0
                  || !
#line 2113 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 462; /* *vec_cmpeqv2df_cc */

            case E_V1TFmode:
              if (pattern273 (x7, 
E_V1TImode, 
E_V1TFmode) != 0
                  || !(
#line 2113 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 463; /* *vec_cmpeqv1tf_cc */

            case E_TFmode:
              if (pattern273 (x7, 
E_TImode, 
E_TFmode) != 0
                  || !(
#line 2113 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 464; /* *vec_cmpeqtf_cc */

            default:
              return -1;
            }

        case GT:
          x8 = XEXP (x7, 0);
          if (!rtx_equal_p (x8, operands[0]))
            return -1;
          x9 = XEXP (x7, 1);
          if (!rtx_equal_p (x9, operands[1]))
            return -1;
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 0);
          switch (GET_MODE (x5))
            {
            case E_CCVIHmode:
              x6 = XEXP (x4, 1);
              if (GET_MODE (x6) != E_CCVIHmode)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern272 (x7, 
E_V16QImode) != 0
                      || !
#line 2040 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 437; /* *vec_cmphv16qi_cc */

                case E_V8HImode:
                  if (pattern272 (x7, 
E_V8HImode) != 0
                      || !
#line 2040 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 438; /* *vec_cmphv8hi_cc */

                case E_V4SImode:
                  if (pattern272 (x7, 
E_V4SImode) != 0
                      || !
#line 2040 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 439; /* *vec_cmphv4si_cc */

                case E_V2DImode:
                  if (pattern272 (x7, 
E_V2DImode) != 0
                      || !
#line 2040 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 440; /* *vec_cmphv2di_cc */

                case E_V1TImode:
                  if (pattern272 (x7, 
E_V1TImode) != 0
                      || !(
#line 2040 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                    return -1;
                  return 441; /* *vec_cmphv1ti_cc */

                case E_TImode:
                  if (pattern272 (x7, 
E_TImode) != 0
                      || !(
#line 2040 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                    return -1;
                  return 442; /* *vec_cmphti_cc */

                default:
                  return -1;
                }

            case E_CCVFHmode:
              x6 = XEXP (x4, 1);
              if (GET_MODE (x6) != E_CCVFHmode)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern273 (x7, 
E_V4SImode, 
E_V4SFmode) != 0
                      || !(
#line 2124 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 465; /* *vec_cmphv4sf_cc */

                case E_V2DFmode:
                  if (pattern273 (x7, 
E_V2DImode, 
E_V2DFmode) != 0
                      || !
#line 2124 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 466; /* *vec_cmphv2df_cc */

                case E_V1TFmode:
                  if (pattern273 (x7, 
E_V1TImode, 
E_V1TFmode) != 0
                      || !(
#line 2124 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 467; /* *vec_cmphv1tf_cc */

                case E_TFmode:
                  if (pattern273 (x7, 
E_TImode, 
E_TFmode) != 0
                      || !(
#line 2124 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 468; /* *vec_cmphtf_cc */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case GTU:
          if (pattern235 (x1, 
E_CCVIHUmode) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern272 (x7, 
E_V16QImode) != 0
                  || !
#line 2050 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 443; /* *vec_cmphlv16qi_cc */

            case E_V8HImode:
              if (pattern272 (x7, 
E_V8HImode) != 0
                  || !
#line 2050 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 444; /* *vec_cmphlv8hi_cc */

            case E_V4SImode:
              if (pattern272 (x7, 
E_V4SImode) != 0
                  || !
#line 2050 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 445; /* *vec_cmphlv4si_cc */

            case E_V2DImode:
              if (pattern272 (x7, 
E_V2DImode) != 0
                  || !
#line 2050 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 446; /* *vec_cmphlv2di_cc */

            case E_V1TImode:
              if (pattern272 (x7, 
E_V1TImode) != 0
                  || !(
#line 2050 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 447; /* *vec_cmphlv1ti_cc */

            case E_TImode:
              if (pattern272 (x7, 
E_TImode) != 0
                  || !(
#line 2050 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 448; /* *vec_cmphlti_cc */

            default:
              return -1;
            }

        case GE:
          if (pattern235 (x1, 
E_CCVFHEmode) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern273 (x7, 
E_V4SImode, 
E_V4SFmode) != 0
                  || !(
#line 2135 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 469; /* *vec_cmphev4sf_cc */

            case E_V2DFmode:
              if (pattern273 (x7, 
E_V2DImode, 
E_V2DFmode) != 0
                  || !
#line 2135 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 470; /* *vec_cmphev2df_cc */

            case E_V1TFmode:
              if (pattern273 (x7, 
E_V1TImode, 
E_V1TFmode) != 0
                  || !(
#line 2135 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 471; /* *vec_cmphev1tf_cc */

            case E_TFmode:
              if (pattern273 (x7, 
E_TImode, 
E_TFmode) != 0
                  || !(
#line 2135 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 472; /* *vec_cmphetf_cc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case USE:
      if (!memory_operand (operands[0], E_BLKmode)
          || !memory_operand (operands[1], E_BLKmode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      if (!const_int_operand (operands[2], E_VOIDmode)
          || !
#line 1500 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode)
   && INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      return 1792; /* *clc */

    default:
      return -1;
    }
}

 int
recog_115 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != MEM
      || pattern98 (x4) != 0)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x7) != USE)
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 33
      || GET_MODE (x9) != E_CCmode)
    return -1;
  x10 = XEXP (x2, 0);
  operands[0] = x10;
  x11 = XEXP (x3, 0);
  operands[1] = x11;
  switch (pattern257 (x1))
    {
    case 0:
      if (!(
#line 3698 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        return -1;
      return 1906; /* *cpymem_long */

    case 1:
      if (!(
#line 3698 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      return 1907; /* *cpymem_long */

    case 2:
      if (!
#line 3711 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
        return -1;
      return 1908; /* *cpymem_long_31z */

    default:
      return -1;
    }
}

 int
recog_117 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40;
  int res ATTRIBUTE_UNUSED;
  if (pattern6 (x1, 
39, 
E_TImode, 
17, 
38) != 0
      || pattern297 (x1, 
41, 
E_TImode, 
19, 
40, 
18) != 0
      || pattern298 (x1, 
43, 
E_TImode, 
21, 
42, 
20) != 0
      || pattern299 (x1, 
E_TImode, 
45, 
23, 
44, 
22) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 18);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 24
      || GET_MODE (x3) != E_TImode)
    return -1;
  x4 = XVECEXP (x1, 0, 19);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 46
      || GET_MODE (x5) != E_TImode)
    return -1;
  x6 = XVECEXP (x1, 0, 20);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 25
      || GET_MODE (x7) != E_TImode)
    return -1;
  x8 = XVECEXP (x1, 0, 21);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 47
      || GET_MODE (x9) != E_TImode)
    return -1;
  x10 = XVECEXP (x1, 0, 22);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 26
      || GET_MODE (x11) != E_TImode)
    return -1;
  x12 = XVECEXP (x1, 0, 23);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 48
      || GET_MODE (x13) != E_TImode)
    return -1;
  x14 = XVECEXP (x1, 0, 24);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 27
      || GET_MODE (x15) != E_TImode)
    return -1;
  x16 = XVECEXP (x1, 0, 25);
  if (GET_CODE (x16) != CLOBBER)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 49
      || GET_MODE (x17) != E_TImode)
    return -1;
  x18 = XVECEXP (x1, 0, 26);
  if (GET_CODE (x18) != CLOBBER)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != REG
      || REGNO (x19) != 28
      || GET_MODE (x19) != E_TImode)
    return -1;
  x20 = XVECEXP (x1, 0, 27);
  if (GET_CODE (x20) != CLOBBER)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 50
      || GET_MODE (x21) != E_TImode)
    return -1;
  x22 = XVECEXP (x1, 0, 28);
  if (GET_CODE (x22) != CLOBBER)
    return -1;
  x23 = XEXP (x22, 0);
  if (GET_CODE (x23) != REG
      || REGNO (x23) != 29
      || GET_MODE (x23) != E_TImode)
    return -1;
  x24 = XVECEXP (x1, 0, 29);
  if (GET_CODE (x24) != CLOBBER)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_CODE (x25) != REG
      || REGNO (x25) != 51
      || GET_MODE (x25) != E_TImode)
    return -1;
  x26 = XVECEXP (x1, 0, 30);
  if (GET_CODE (x26) != CLOBBER)
    return -1;
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != REG
      || REGNO (x27) != 30
      || GET_MODE (x27) != E_TImode)
    return -1;
  x28 = XVECEXP (x1, 0, 31);
  if (GET_CODE (x28) != CLOBBER)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_CODE (x29) != REG
      || REGNO (x29) != 52
      || GET_MODE (x29) != E_TImode)
    return -1;
  x30 = XVECEXP (x1, 0, 32);
  if (GET_CODE (x30) != CLOBBER)
    return -1;
  x31 = XEXP (x30, 0);
  if (GET_CODE (x31) != REG
      || REGNO (x31) != 31
      || GET_MODE (x31) != E_TImode)
    return -1;
  x32 = XVECEXP (x1, 0, 33);
  if (GET_CODE (x32) != CLOBBER)
    return -1;
  x33 = XEXP (x32, 0);
  if (GET_CODE (x33) != REG
      || REGNO (x33) != 53
      || GET_MODE (x33) != E_TImode)
    return -1;
  x34 = XVECEXP (x1, 0, 0);
  x35 = XEXP (x34, 1);
  x36 = XVECEXP (x35, 0, 0);
  operands[0] = x36;
  if (!const_int_operand (operands[0], E_VOIDmode))
    return -1;
  x37 = XVECEXP (x1, 0, 1);
  x38 = XEXP (x37, 0);
  operands[1] = x38;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x39 = XEXP (x37, 1);
  x40 = XVECEXP (x39, 0, 0);
  if (!rtx_equal_p (x40, operands[0])
      || !
#line 12384 "../../gcc/config/s390/s390.md"
(TARGET_VX && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
    return -1;
  return 2666; /* tbegin_1_z13 */
}

 int
recog_120 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case UNSPEC:
      return recog_63 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      return recog_59 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_58 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_55 (x1, insn, pnum_clobbers);

    case COMPARE:
      return recog_57 (x1, insn, pnum_clobbers);

    case BSWAP:
      return recog_69 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      return recog_77 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      return recog_64 (x1, insn, pnum_clobbers);

    case DIV:
      return recog_72 (x1, insn, pnum_clobbers);

    case UDIV:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 1285 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 738; /* udivv4si3 */

        case 1:
          if (!
#line 1285 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 739; /* udivv2di3 */

        case 2:
          if (!
#line 1285 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 740; /* udivv1ti3 */

        case 3:
          if (!
#line 1285 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 741; /* udivti3 */

        default:
          return -1;
        }

    case MOD:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 1294 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 742; /* modv4si3 */

        case 1:
          if (!
#line 1294 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 743; /* modv2di3 */

        case 2:
          if (!
#line 1294 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 744; /* modv1ti3 */

        case 3:
          if (!
#line 1294 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 745; /* modti3 */

        default:
          return -1;
        }

    case UMOD:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 1303 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 746; /* umodv4si3 */

        case 1:
          if (!
#line 1303 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 747; /* umodv2di3 */

        case 2:
          if (!
#line 1303 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 748; /* umodv1ti3 */

        case 3:
          if (!
#line 1303 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 749; /* umodti3 */

        default:
          return -1;
        }

    case NEG:
      return recog_56 (x1, insn, pnum_clobbers);

    case ABS:
      return recog_60 (x1, insn, pnum_clobbers);

    case XOR:
      return recog_61 (x1, insn, pnum_clobbers);

    case CLZ:
      switch (pattern2 (x1))
        {
        case 0:
          if (!
#line 1557 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 943; /* clzv1qi2 */

        case 1:
          if (!
#line 1557 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 944; /* clzv2qi2 */

        case 2:
          if (!
#line 1557 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 945; /* clzv4qi2 */

        case 3:
          if (!
#line 1557 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 946; /* clzv8qi2 */

        case 4:
          if (!
#line 1557 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 947; /* clzv16qi2 */

        case 5:
          if (!
#line 1557 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 948; /* clzv1hi2 */

        case 6:
          if (!
#line 1557 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 949; /* clzv2hi2 */

        case 7:
          if (!
#line 1557 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 950; /* clzv4hi2 */

        case 8:
          if (!
#line 1557 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 951; /* clzv8hi2 */

        case 9:
          if (!
#line 1557 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 952; /* clzv1si2 */

        case 10:
          if (!
#line 1557 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 953; /* clzv2si2 */

        case 11:
          if (!
#line 1557 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 954; /* clzv4si2 */

        case 12:
          if (!
#line 1557 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 955; /* clzv1di2 */

        case 13:
          if (!
#line 1557 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 956; /* clzv2di2 */

        case 14:
          if (!
#line 1557 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 957; /* clzv1sf2 */

        case 15:
          if (!
#line 1557 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 958; /* clzv2sf2 */

        case 16:
          if (!
#line 1557 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 959; /* clzv4sf2 */

        case 17:
          if (!
#line 1557 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 960; /* clzv1df2 */

        case 18:
          if (!
#line 1557 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 961; /* clzv2df2 */

        case 19:
          if (!
#line 1557 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 962; /* clzv1tf2 */

        case 20:
          if (!(
#line 1557 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 30 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 963; /* clzv1ti2 */

        case 21:
          if (!(
#line 1557 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 30 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 964; /* clzti2 */

        case 22:
          if (!
#line 9611 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
            return -1;
          return 2517; /* *clzg */

        default:
          return -1;
        }

    case CTZ:
      return recog_79 (x1, insn, pnum_clobbers);

    case ROTATE:
      return recog_67 (x1, insn, pnum_clobbers);

    case ASHIFT:
      return recog_65 (x1, insn, pnum_clobbers);

    case ASHIFTRT:
      return recog_62 (x1, insn, pnum_clobbers);

    case LSHIFTRT:
      return recog_66 (x1, insn, pnum_clobbers);

    case SMIN:
      switch (pattern3 (x1))
        {
        case 0:
          if (!
#line 1753 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1119; /* *sminv1qi3 */

        case 1:
          if (!
#line 1753 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1120; /* *sminv2qi3 */

        case 2:
          if (!
#line 1753 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1121; /* *sminv4qi3 */

        case 3:
          if (!
#line 1753 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1122; /* *sminv8qi3 */

        case 4:
          if (!
#line 1753 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1123; /* *sminv16qi3 */

        case 5:
          if (!
#line 1753 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1124; /* *sminv1hi3 */

        case 6:
          if (!
#line 1753 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1125; /* *sminv2hi3 */

        case 7:
          if (!
#line 1753 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1126; /* *sminv4hi3 */

        case 8:
          if (!
#line 1753 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1127; /* *sminv8hi3 */

        case 9:
          if (!
#line 1753 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1128; /* *sminv1si3 */

        case 10:
          if (!
#line 1753 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1129; /* *sminv2si3 */

        case 11:
          if (!
#line 1753 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1130; /* *sminv4si3 */

        case 12:
          if (!
#line 1753 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1131; /* *sminv1di3 */

        case 13:
          if (!
#line 1753 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1132; /* *sminv2di3 */

        case 14:
          if (!(
#line 1753 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1133; /* *sminv1ti3 */

        case 15:
          if (!(
#line 1753 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1134; /* *sminti3 */

        case 16:
          if (!
#line 2172 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1301; /* *sminv4sf3_vxe */

        case 17:
          if (
#line 2172 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return 1302; /* *sminv2df3_vxe */
          if (!
#line 2181 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE))
            return -1;
          return 1305; /* *sminv2df3_vx */

        case 18:
          if (!
#line 2172 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1303; /* *sminv1tf3_vxe */

        case 19:
          if (!
#line 2172 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1304; /* *smintf3_vxe */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern3 (x1))
        {
        case 0:
          if (!
#line 1778 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1135; /* *smaxv1qi3 */

        case 1:
          if (!
#line 1778 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1136; /* *smaxv2qi3 */

        case 2:
          if (!
#line 1778 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1137; /* *smaxv4qi3 */

        case 3:
          if (!
#line 1778 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1138; /* *smaxv8qi3 */

        case 4:
          if (!
#line 1778 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1139; /* *smaxv16qi3 */

        case 5:
          if (!
#line 1778 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1140; /* *smaxv1hi3 */

        case 6:
          if (!
#line 1778 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1141; /* *smaxv2hi3 */

        case 7:
          if (!
#line 1778 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1142; /* *smaxv4hi3 */

        case 8:
          if (!
#line 1778 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1143; /* *smaxv8hi3 */

        case 9:
          if (!
#line 1778 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1144; /* *smaxv1si3 */

        case 10:
          if (!
#line 1778 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1145; /* *smaxv2si3 */

        case 11:
          if (!
#line 1778 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1146; /* *smaxv4si3 */

        case 12:
          if (!
#line 1778 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1147; /* *smaxv1di3 */

        case 13:
          if (!
#line 1778 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1148; /* *smaxv2di3 */

        case 14:
          if (!(
#line 1778 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1149; /* *smaxv1ti3 */

        case 15:
          if (!(
#line 1778 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1150; /* *smaxti3 */

        case 16:
          if (!
#line 2136 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1296; /* *smaxv4sf3_vxe */

        case 17:
          if (
#line 2136 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return 1297; /* *smaxv2df3_vxe */
          if (!
#line 2145 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE))
            return -1;
          return 1300; /* *smaxv2df3_vx */

        case 18:
          if (!
#line 2136 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1298; /* *smaxv1tf3_vxe */

        case 19:
          if (!
#line 2136 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1299; /* *smaxtf3_vxe */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern4 (x1))
        {
        case 0:
          if (!
#line 1803 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1151; /* *uminv1qi3 */

        case 1:
          if (!
#line 1803 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1152; /* *uminv2qi3 */

        case 2:
          if (!
#line 1803 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1153; /* *uminv4qi3 */

        case 3:
          if (!
#line 1803 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1154; /* *uminv8qi3 */

        case 4:
          if (!
#line 1803 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1155; /* *uminv16qi3 */

        case 5:
          if (!
#line 1803 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1156; /* *uminv1hi3 */

        case 6:
          if (!
#line 1803 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1157; /* *uminv2hi3 */

        case 7:
          if (!
#line 1803 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1158; /* *uminv4hi3 */

        case 8:
          if (!
#line 1803 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1159; /* *uminv8hi3 */

        case 9:
          if (!
#line 1803 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1160; /* *uminv1si3 */

        case 10:
          if (!
#line 1803 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1161; /* *uminv2si3 */

        case 11:
          if (!
#line 1803 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1162; /* *uminv4si3 */

        case 12:
          if (!
#line 1803 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1163; /* *uminv1di3 */

        case 13:
          if (!
#line 1803 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1164; /* *uminv2di3 */

        case 14:
          if (!(
#line 1803 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1165; /* *uminv1ti3 */

        case 15:
          if (!(
#line 1803 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1166; /* *uminti3 */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern4 (x1))
        {
        case 0:
          if (!
#line 1828 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1167; /* *umaxv1qi3 */

        case 1:
          if (!
#line 1828 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1168; /* *umaxv2qi3 */

        case 2:
          if (!
#line 1828 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1169; /* *umaxv4qi3 */

        case 3:
          if (!
#line 1828 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1170; /* *umaxv8qi3 */

        case 4:
          if (!
#line 1828 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1171; /* *umaxv16qi3 */

        case 5:
          if (!
#line 1828 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1172; /* *umaxv1hi3 */

        case 6:
          if (!
#line 1828 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1173; /* *umaxv2hi3 */

        case 7:
          if (!
#line 1828 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1174; /* *umaxv4hi3 */

        case 8:
          if (!
#line 1828 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1175; /* *umaxv8hi3 */

        case 9:
          if (!
#line 1828 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1176; /* *umaxv1si3 */

        case 10:
          if (!
#line 1828 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1177; /* *umaxv2si3 */

        case 11:
          if (!
#line 1828 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1178; /* *umaxv4si3 */

        case 12:
          if (!
#line 1828 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1179; /* *umaxv1di3 */

        case 13:
          if (!
#line 1828 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1180; /* *umaxv2di3 */

        case 14:
          if (!(
#line 1828 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1181; /* *umaxv1ti3 */

        case 15:
          if (!(
#line 1828 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1182; /* *umaxti3 */

        default:
          return -1;
        }

    case SQRT:
      return recog_73 (x1, insn, pnum_clobbers);

    case FMA:
      return recog_76 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      return recog_78 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      return recog_70 (x1, insn, pnum_clobbers);

    case FLOAT:
      return recog_75 (x1, insn, pnum_clobbers);

    case UNSIGNED_FLOAT:
      return recog_71 (x1, insn, pnum_clobbers);

    case FIX:
      switch (pattern5 (x1))
        {
        case 0:
          if (!
#line 3145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1547; /* fix_truncv2dfv2di2 */

        case 1:
          if (!(
#line 3145 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 101 "../../gcc/config/s390/vector.md"
(TARGET_VXE2)))
            return -1;
          return 1548; /* fix_truncv4sfv4si2 */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern5 (x1))
        {
        case 0:
          if (!
#line 3177 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1549; /* fixuns_truncv2dfv2di2 */

        case 1:
          if (!(
#line 3177 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 101 "../../gcc/config/s390/vector.md"
(TARGET_VXE2)))
            return -1;
          return 1550; /* fixuns_truncv4sfv4si2 */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      x3 = XEXP (x2, 2);
      if (GET_CODE (x3) != CONST_INT)
        return -1;
      operands[3] = x3;
      if (const_int_operand (operands[3], E_VOIDmode))
        {
          res = recog_34 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (pnum_clobbers == NULL
          || XWINT (x3, 0) != 0L)
        return -1;
      switch (pattern34 (x1))
        {
        case 0:
          if (!(
#line 4415 "../../gcc/config/s390/s390.md"
(!TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1964; /* *pre_z10_extzvdi */

        case 1:
          if (!
#line 4415 "../../gcc/config/s390/s390.md"
(!TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 1965; /* *pre_z10_extzvsi */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XEXP (x2, 2);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern34 (x1))
        {
        case 0:
          if (!
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 1966; /* *pre_z10_extvdi */

        case 1:
          *pnum_clobbers = 1;
          return 1967; /* *pre_z10_extvsi */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (!register_operand (operands[1], E_DFmode)
                  || !
#line 5701 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2108; /* truncdfsf2 */

            case E_TFmode:
              if (pnum_clobbers == NULL
                  || !register_operand (operands[1], E_TFmode)
                  || !
#line 5719 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2110; /* trunctfsf2_fpr */

            default:
              return -1;
            }

        case E_DFmode:
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !register_operand (operands[1], E_TFmode)
              || !
#line 5719 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2109; /* trunctfdf2_fpr */

        case E_SDmode:
          if (!register_operand (operands[0], E_SDmode)
              || GET_MODE (x2) != E_SDmode
              || !register_operand (operands[1], E_DDmode)
              || !
#line 5750 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2112; /* truncddsd2 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      return recog_68 (x1, insn, pnum_clobbers);

    case CALL:
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != MEM
          || GET_MODE (x5) != E_QImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x6 = XEXP (x2, 1);
      if (!const_int_operand (x6, E_VOIDmode))
        return -1;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case REG:
          if (REGNO (x7) != 1)
            return -1;
          operands[1] = x6;
          if (!
#line 10805 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn)
   && GET_MODE (XEXP (XEXP (XEXP (PATTERN (insn), 1), 0), 0)) == Pmode))
            return -1;
          return 2582; /* *sibcall_value_br */

        case CONST:
        case SYMBOL_REF:
          operands[1] = x7;
          if (!bras_sym_operand (operands[1], E_VOIDmode))
            return -1;
          operands[2] = x6;
          if (
#line 10835 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn) && TARGET_SMALL_EXEC))
            return 2583; /* *sibcall_value_brc */
          if (!
#line 10844 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn)))
            return -1;
          return 2584; /* *sibcall_value_brcl */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      return recog_74 (x1, insn, pnum_clobbers);

    case POPCOUNT:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_DImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 12110 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
        return -1;
      *pnum_clobbers = 1;
      return 2654; /* *popcountdi_z15 */

    case COPYSIGN:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_TFmode:
          if (pattern0 (x2, 
E_TFmode) != 0
              || !(
#line 12277 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2659; /* copysigntf3_fpr */

        case E_FPRX2mode:
          if (pattern0 (x2, 
E_FPRX2mode) != 0
              || !(
#line 12277 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2660; /* copysignfprx23 */

        case E_DFmode:
          if (pattern0 (x2, 
E_DFmode) != 0
              || !
#line 12277 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2661; /* copysigndf3 */

        case E_SFmode:
          if (pattern0 (x2, 
E_SFmode) != 0
              || !
#line 12277 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2662; /* copysignsf3 */

        case E_TDmode:
          if (pattern0 (x2, 
E_TDmode) != 0
              || !(
#line 12277 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2663; /* copysigntd3 */

        case E_DDmode:
          if (pattern0 (x2, 
E_DDmode) != 0
              || !(
#line 12277 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2664; /* copysigndd3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
