/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern0 (x3, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern0 (x3, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern0 (x3, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern0 (x3, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern0 (x3, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern0 (x3, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern0 (x3, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern0 (x3, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern0 (x3, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern0 (x3, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V1TImode:
      if (pattern0 (x3, 
E_V1TImode) != 0)
        return -1;
      return 14;

    case E_TImode:
      if (pattern0 (x3, 
E_TImode) != 0)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern22 (x3, 
E_V16QImode); /* [-1, 2] */

    case E_V8HImode:
      res = pattern22 (x3, 
E_V8HImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_V4SImode:
      res = pattern22 (x3, 
E_V4SImode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    case E_V2DImode:
      res = pattern22 (x3, 
E_V2DImode);
      if (res >= 0)
        return res + 9; /* [9, 11] */
      return -1;

    case E_V1TImode:
      res = pattern22 (x3, 
E_V1TImode);
      if (res >= 0)
        return res + 12; /* [12, 14] */
      return -1;

    case E_TImode:
      res = pattern22 (x3, 
E_TImode);
      if (res >= 0)
        return res + 15; /* [15, 17] */
      return -1;

    case E_V4SFmode:
      res = pattern22 (x3, 
E_V4SFmode);
      if (res >= 0)
        return res + 18; /* [18, 20] */
      return -1;

    case E_V2DFmode:
      res = pattern22 (x3, 
E_V2DFmode);
      if (res >= 0)
        return res + 21; /* [21, 23] */
      return -1;

    case E_V1TFmode:
      res = pattern22 (x3, 
E_V1TFmode);
      if (res >= 0)
        return res + 24; /* [24, 26] */
      return -1;

    case E_TFmode:
      res = pattern22 (x3, 
E_TFmode);
      if (res >= 0)
        return res + 27; /* [27, 29] */
      return -1;

    default:
      return -1;
    }
}

int
pattern34 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!s_operand (operands[1], E_QImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!nonzero_shift_count_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern41 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 33
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern46 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern52 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern51 (x1, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern51 (x1, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern51 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern51 (x1, 
E_V2DImode) != 0)
        return -1;
      return 3;

    case E_V1TImode:
      if (pattern51 (x1, 
E_V1TImode) != 0)
        return -1;
      return 4;

    case E_TImode:
      if (pattern51 (x1, 
E_TImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern60 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode
      || !nonimmediate_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || GET_MODE (x2) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!nonimmediate_operand (operands[1], E_DImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern71 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern76 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_MODE (x10) != i1
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern85 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern90 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  return 0;
}

int
pattern96 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern95 (x5); /* [-1, 1] */
}

int
pattern103 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  return 0;
}

int
pattern115 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1)
      || !contiguous_bitmask_nowrap_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern119 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (maybe_ne (SUBREG_BYTE (x4), 4)
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != ZERO_EXTRACT
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 33
      || GET_MODE (x8) != E_CCmode
      || !nonimmediate_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x9 = XEXP (x5, 0);
  operands[1] = x9;
  if (!nonimmediate_operand (operands[1], E_DImode))
    return -1;
  x10 = XEXP (x5, 2);
  operands[2] = x10;
  if (!immediate_operand (operands[2], E_DImode))
    return -1;
  x11 = XEXP (x3, 1);
  operands[3] = x11;
  if (!nonimmediate_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern134 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (x1))
        {
        case E_DImode:
          if (GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !register_operand (operands[2], E_DImode))
            return -1;
          return 0;

        case E_SImode:
          if (GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_SImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      switch (GET_MODE (x1))
        {
        case E_DImode:
          if (pattern133 (x1, 
E_DImode) != 0)
            return -1;
          return 2;

        case E_SImode:
          if (pattern133 (x1, 
E_SImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern150 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern149 (x1); /* [-1, 5] */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode))
            return -1;
          switch (GET_MODE (x6))
            {
            case E_DImode:
              if (!immediate_operand (operands[2], E_DImode))
                return -1;
              return 6;

            case E_SImode:
              if (!immediate_operand (operands[2], E_SImode))
                return -1;
              return 7;

            default:
              return -1;
            }

        case E_TFmode:
          if (!register_operand (operands[1], E_TFmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 8;

        case E_FPRX2mode:
          if (!register_operand (operands[1], E_FPRX2mode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 9;

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 10;

        case E_TDmode:
          if (!register_operand (operands[1], E_TDmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 11;

        case E_DDmode:
          if (!register_operand (operands[1], E_DDmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 12;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern176 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !memory_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern187 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !general_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !general_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern196 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != USE)
    return -1;
  return 0;
}

int
pattern197 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern203 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern209 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern216 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern226 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern236 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern240 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern246 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern255 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !const0_operand (operands[3], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern263 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !immediate_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern272 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern276 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern288 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern296 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern23 (x1))
    {
    case 0:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 207; /* vec_sllv16qiv16qi */

    case 1:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 217; /* vec_sllv16qiv8hi */

    case 2:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 227; /* vec_sllv16qiv4si */

    case 3:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 208; /* vec_sllv8hiv16qi */

    case 4:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 218; /* vec_sllv8hiv8hi */

    case 5:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 228; /* vec_sllv8hiv4si */

    case 6:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 209; /* vec_sllv4siv16qi */

    case 7:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 219; /* vec_sllv4siv8hi */

    case 8:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 229; /* vec_sllv4siv4si */

    case 9:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 210; /* vec_sllv2div16qi */

    case 10:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 220; /* vec_sllv2div8hi */

    case 11:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 230; /* vec_sllv2div4si */

    case 12:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 211; /* vec_sllv1tiv16qi */

    case 13:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 221; /* vec_sllv1tiv8hi */

    case 14:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 231; /* vec_sllv1tiv4si */

    case 15:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 212; /* vec_slltiv16qi */

    case 16:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 222; /* vec_slltiv8hi */

    case 17:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 232; /* vec_slltiv4si */

    case 18:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 213; /* vec_sllv4sfv16qi */

    case 19:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 223; /* vec_sllv4sfv8hi */

    case 20:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 233; /* vec_sllv4sfv4si */

    case 21:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 214; /* vec_sllv2dfv16qi */

    case 22:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 224; /* vec_sllv2dfv8hi */

    case 23:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 234; /* vec_sllv2dfv4si */

    case 24:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 215; /* vec_sllv1tfv16qi */

    case 25:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 225; /* vec_sllv1tfv8hi */

    case 26:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 235; /* vec_sllv1tfv4si */

    case 27:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 216; /* vec_slltfv16qi */

    case 28:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 226; /* vec_slltfv8hi */

    case 29:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 236; /* vec_slltfv4si */

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case NOT:
      x4 = XEXP (x2, 0);
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern130 (x2, 
E_V1QImode) != 0
              || !
#line 1387 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 806; /* notandv1qi3 */

        case E_V2QImode:
          if (pattern130 (x2, 
E_V2QImode) != 0
              || !
#line 1387 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 807; /* notandv2qi3 */

        case E_V4QImode:
          if (pattern130 (x2, 
E_V4QImode) != 0
              || !
#line 1387 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 808; /* notandv4qi3 */

        case E_V8QImode:
          if (pattern130 (x2, 
E_V8QImode) != 0
              || !
#line 1387 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 809; /* notandv8qi3 */

        case E_V16QImode:
          if (pattern130 (x2, 
E_V16QImode) != 0
              || !
#line 1387 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 810; /* notandv16qi3 */

        case E_V1HImode:
          if (pattern130 (x2, 
E_V1HImode) != 0
              || !
#line 1387 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 811; /* notandv1hi3 */

        case E_V2HImode:
          if (pattern130 (x2, 
E_V2HImode) != 0
              || !
#line 1387 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 812; /* notandv2hi3 */

        case E_V4HImode:
          if (pattern130 (x2, 
E_V4HImode) != 0
              || !
#line 1387 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 813; /* notandv4hi3 */

        case E_V8HImode:
          if (pattern130 (x2, 
E_V8HImode) != 0
              || !
#line 1387 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 814; /* notandv8hi3 */

        case E_V1SImode:
          if (pattern130 (x2, 
E_V1SImode) != 0
              || !
#line 1387 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 815; /* notandv1si3 */

        case E_V2SImode:
          if (pattern130 (x2, 
E_V2SImode) != 0
              || !
#line 1387 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 816; /* notandv2si3 */

        case E_V4SImode:
          if (pattern130 (x2, 
E_V4SImode) != 0
              || !
#line 1387 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 817; /* notandv4si3 */

        case E_V1DImode:
          if (pattern130 (x2, 
E_V1DImode) != 0
              || !
#line 1387 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 818; /* notandv1di3 */

        case E_V2DImode:
          if (pattern130 (x2, 
E_V2DImode) != 0
              || !
#line 1387 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 819; /* notandv2di3 */

        case E_V1SFmode:
          if (pattern130 (x2, 
E_V1SFmode) != 0
              || !
#line 1387 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 820; /* notandv1sf3 */

        case E_V2SFmode:
          if (pattern130 (x2, 
E_V2SFmode) != 0
              || !
#line 1387 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 821; /* notandv2sf3 */

        case E_V4SFmode:
          if (pattern130 (x2, 
E_V4SFmode) != 0
              || !
#line 1387 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 822; /* notandv4sf3 */

        case E_V1DFmode:
          if (pattern130 (x2, 
E_V1DFmode) != 0
              || !
#line 1387 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 823; /* notandv1df3 */

        case E_V2DFmode:
          if (pattern130 (x2, 
E_V2DFmode) != 0
              || !
#line 1387 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 824; /* notandv2df3 */

        case E_V1TFmode:
          if (pattern130 (x2, 
E_V1TFmode) != 0
              || !
#line 1387 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 825; /* notandv1tf3 */

        case E_V1TImode:
          if (pattern130 (x2, 
E_V1TImode) != 0
              || !
#line 1387 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 826; /* notandv1ti3 */

        case E_TImode:
          if (pattern130 (x2, 
E_TImode) != 0
              || !
#line 1387 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 827; /* notandti3 */

        case E_DImode:
          if (pnum_clobbers == NULL
              || pattern130 (x2, 
E_DImode) != 0
              || !(
#line 8652 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2412; /* *nanddi */

        case E_SImode:
          if (pnum_clobbers == NULL
              || pattern130 (x2, 
E_SImode) != 0
              || !
#line 8652 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
            return -1;
          *pnum_clobbers = 1;
          return 2414; /* *nandsi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern81 (x2, 
E_V1QImode) != 0
              || !
#line 1407 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 850; /* ior_notv1qi3 */

        case E_V2QImode:
          if (pattern81 (x2, 
E_V2QImode) != 0
              || !
#line 1407 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 851; /* ior_notv2qi3 */

        case E_V4QImode:
          if (pattern81 (x2, 
E_V4QImode) != 0
              || !
#line 1407 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 852; /* ior_notv4qi3 */

        case E_V8QImode:
          if (pattern81 (x2, 
E_V8QImode) != 0
              || !
#line 1407 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 853; /* ior_notv8qi3 */

        case E_V16QImode:
          if (pattern81 (x2, 
E_V16QImode) != 0
              || !
#line 1407 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 854; /* ior_notv16qi3 */

        case E_V1HImode:
          if (pattern81 (x2, 
E_V1HImode) != 0
              || !
#line 1407 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 855; /* ior_notv1hi3 */

        case E_V2HImode:
          if (pattern81 (x2, 
E_V2HImode) != 0
              || !
#line 1407 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 856; /* ior_notv2hi3 */

        case E_V4HImode:
          if (pattern81 (x2, 
E_V4HImode) != 0
              || !
#line 1407 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 857; /* ior_notv4hi3 */

        case E_V8HImode:
          if (pattern81 (x2, 
E_V8HImode) != 0
              || !
#line 1407 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 858; /* ior_notv8hi3 */

        case E_V1SImode:
          if (pattern81 (x2, 
E_V1SImode) != 0
              || !
#line 1407 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 859; /* ior_notv1si3 */

        case E_V2SImode:
          if (pattern81 (x2, 
E_V2SImode) != 0
              || !
#line 1407 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 860; /* ior_notv2si3 */

        case E_V4SImode:
          if (pattern81 (x2, 
E_V4SImode) != 0
              || !
#line 1407 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 861; /* ior_notv4si3 */

        case E_V1DImode:
          if (pattern81 (x2, 
E_V1DImode) != 0
              || !
#line 1407 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 862; /* ior_notv1di3 */

        case E_V2DImode:
          if (pattern81 (x2, 
E_V2DImode) != 0
              || !
#line 1407 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 863; /* ior_notv2di3 */

        case E_V1SFmode:
          if (pattern81 (x2, 
E_V1SFmode) != 0
              || !
#line 1407 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 864; /* ior_notv1sf3 */

        case E_V2SFmode:
          if (pattern81 (x2, 
E_V2SFmode) != 0
              || !
#line 1407 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 865; /* ior_notv2sf3 */

        case E_V4SFmode:
          if (pattern81 (x2, 
E_V4SFmode) != 0
              || !
#line 1407 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 866; /* ior_notv4sf3 */

        case E_V1DFmode:
          if (pattern81 (x2, 
E_V1DFmode) != 0
              || !
#line 1407 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 867; /* ior_notv1df3 */

        case E_V2DFmode:
          if (pattern81 (x2, 
E_V2DFmode) != 0
              || !
#line 1407 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 868; /* ior_notv2df3 */

        case E_V1TFmode:
          if (pattern81 (x2, 
E_V1TFmode) != 0
              || !
#line 1407 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 869; /* ior_notv1tf3 */

        case E_V1TImode:
          if (pattern81 (x2, 
E_V1TImode) != 0
              || !
#line 1407 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 870; /* ior_notv1ti3 */

        case E_TImode:
          if (pattern81 (x2, 
E_TImode) != 0
              || !
#line 1407 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 871; /* ior_notti3 */

        case E_DImode:
          if (pattern82 (x2, pnum_clobbers, 
E_DImode) != 0
              || !(
#line 8612 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2400; /* *orcdi */

        case E_SImode:
          if (pattern82 (x2, pnum_clobbers, 
E_SImode) != 0
              || !
#line 8612 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
            return -1;
          *pnum_clobbers = 1;
          return 2402; /* *orcsi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  if (!nonzero_shift_count_operand (operands[4], E_DImode))
    return -1;
  if (
#line 4334 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && 64 - UINTVAL (operands[4]) >= UINTVAL (operands[1])))
    return 1942; /* *extzvdi_nocc_lshiftrt */
  if (pnum_clobbers == NULL
      || !
#line 4334 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && 64 - UINTVAL (operands[4]) >= UINTVAL (operands[1])))
    return -1;
  *pnum_clobbers = 1;
  return 1943; /* *extzvdi_clobbercc_lshiftrt */
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (pattern203 (x2, 
E_V1QImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1QImode)
          && 
#line 2697 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1431; /* vec_sel0v1qi */
      if (!all_ones_operand (operands[4], E_V1QImode)
          || !
#line 2721 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1472; /* *vec_sel1v1qi */

    case E_V2QImode:
      if (pattern203 (x2, 
E_V2QImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2QImode)
          && 
#line 2697 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1432; /* vec_sel0v2qi */
      if (!all_ones_operand (operands[4], E_V2QImode)
          || !
#line 2721 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1473; /* *vec_sel1v2qi */

    case E_V4QImode:
      if (pattern203 (x2, 
E_V4QImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V4QImode)
          && 
#line 2697 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1433; /* vec_sel0v4qi */
      if (!all_ones_operand (operands[4], E_V4QImode)
          || !
#line 2721 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1474; /* *vec_sel1v4qi */

    case E_V8QImode:
      if (pattern203 (x2, 
E_V8QImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V8QImode)
          && 
#line 2697 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1434; /* vec_sel0v8qi */
      if (!all_ones_operand (operands[4], E_V8QImode)
          || !
#line 2721 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1475; /* *vec_sel1v8qi */

    case E_V16QImode:
      if (pattern203 (x2, 
E_V16QImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V16QImode)
          && 
#line 2697 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1435; /* vec_sel0v16qi */
      if (!all_ones_operand (operands[4], E_V16QImode)
          || !
#line 2721 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1476; /* *vec_sel1v16qi */

    case E_V1HImode:
      if (pattern203 (x2, 
E_V1HImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1HImode)
          && 
#line 2697 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1436; /* vec_sel0v1hi */
      if (!all_ones_operand (operands[4], E_V1HImode)
          || !
#line 2721 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1477; /* *vec_sel1v1hi */

    case E_V2HImode:
      if (pattern203 (x2, 
E_V2HImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2HImode)
          && 
#line 2697 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1437; /* vec_sel0v2hi */
      if (!all_ones_operand (operands[4], E_V2HImode)
          || !
#line 2721 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1478; /* *vec_sel1v2hi */

    case E_V4HImode:
      if (pattern203 (x2, 
E_V4HImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V4HImode)
          && 
#line 2697 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1438; /* vec_sel0v4hi */
      if (!all_ones_operand (operands[4], E_V4HImode)
          || !
#line 2721 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1479; /* *vec_sel1v4hi */

    case E_V8HImode:
      if (pattern203 (x2, 
E_V8HImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V8HImode)
          && 
#line 2697 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1439; /* vec_sel0v8hi */
      if (!all_ones_operand (operands[4], E_V8HImode)
          || !
#line 2721 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1480; /* *vec_sel1v8hi */

    case E_V1SImode:
      if (pattern203 (x2, 
E_V1SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1SImode)
          && 
#line 2697 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1440; /* vec_sel0v1si */
      if (!all_ones_operand (operands[4], E_V1SImode)
          || !
#line 2721 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1481; /* *vec_sel1v1si */

    case E_V2SImode:
      if (pattern203 (x2, 
E_V2SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2SImode)
          && 
#line 2697 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1441; /* vec_sel0v2si */
      if (!all_ones_operand (operands[4], E_V2SImode)
          || !
#line 2721 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1482; /* *vec_sel1v2si */

    case E_V4SImode:
      if (pattern203 (x2, 
E_V4SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V4SImode)
          && 
#line 2697 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1442; /* vec_sel0v4si */
      if (!all_ones_operand (operands[4], E_V4SImode)
          || !
#line 2721 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1483; /* *vec_sel1v4si */

    case E_V1DImode:
      if (pattern203 (x2, 
E_V1DImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1DImode)
          && 
#line 2697 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1443; /* vec_sel0v1di */
      if (!all_ones_operand (operands[4], E_V1DImode)
          || !
#line 2721 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1484; /* *vec_sel1v1di */

    case E_V2DImode:
      if (pattern203 (x2, 
E_V2DImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2DImode)
          && 
#line 2697 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1444; /* vec_sel0v2di */
      if (!all_ones_operand (operands[4], E_V2DImode)
          || !
#line 2721 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1485; /* *vec_sel1v2di */

    case E_V1SFmode:
      if (pattern204 (x2, 
E_V1SFmode, 
E_V1SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1SImode)
          && 
#line 2697 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1445; /* vec_sel0v1sf */
      if (!all_ones_operand (operands[4], E_V1SImode)
          || !
#line 2721 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1486; /* *vec_sel1v1sf */

    case E_V2SFmode:
      if (pattern204 (x2, 
E_V2SFmode, 
E_V2SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2SImode)
          && 
#line 2697 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1446; /* vec_sel0v2sf */
      if (!all_ones_operand (operands[4], E_V2SImode)
          || !
#line 2721 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1487; /* *vec_sel1v2sf */

    case E_V4SFmode:
      if (pattern204 (x2, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V4SImode)
          && 
#line 2697 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1447; /* vec_sel0v4sf */
      if (!all_ones_operand (operands[4], E_V4SImode)
          || !
#line 2721 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1488; /* *vec_sel1v4sf */

    case E_V1DFmode:
      if (pattern204 (x2, 
E_V1DFmode, 
E_V1DImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1DImode)
          && 
#line 2697 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1448; /* vec_sel0v1df */
      if (!all_ones_operand (operands[4], E_V1DImode)
          || !
#line 2721 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1489; /* *vec_sel1v1df */

    case E_V2DFmode:
      if (pattern204 (x2, 
E_V2DFmode, 
E_V2DImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2DImode)
          && 
#line 2697 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1449; /* vec_sel0v2df */
      if (!all_ones_operand (operands[4], E_V2DImode)
          || !
#line 2721 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1490; /* *vec_sel1v2df */

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x2) != E_V1TFmode
          || !register_operand (operands[3], E_V1TImode)
          || !const0_operand (operands[4], E_V1TImode)
          || !register_operand (operands[1], E_V1TFmode)
          || !register_operand (operands[2], E_V1TFmode)
          || !
#line 2697 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1450; /* vec_sel0v1tf */

    case E_V1TImode:
      if (pattern205 (x2, 
E_V1TImode) != 0
          || !
#line 2697 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1451; /* vec_sel0v1ti */

    case E_TImode:
      if (pattern205 (x2, 
E_TImode) != 0
          || !
#line 2697 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1452; /* vec_sel0ti */

    default:
      return -1;
    }
}

 int
recog_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  switch (GET_MODE (x2))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !nonimmediate_operand (operands[3], E_DImode))
        return -1;
      if ((
#line 4486 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (DImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 64) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return 1968; /* *insvdi_nocc */
      if (pnum_clobbers == NULL
          || !(
#line 4486 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (DImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 64) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      *pnum_clobbers = 1;
      return 1969; /* *insvdi_clobbercc */

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !nonimmediate_operand (operands[3], E_SImode))
        return -1;
      if (
#line 4486 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (SImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 32))
        return 1970; /* *insvsi_nocc */
      if (pnum_clobbers == NULL
          || !
#line 4486 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (SImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 32))
        return -1;
      *pnum_clobbers = 1;
      return 1971; /* *insvsi_clobbercc */

    default:
      return -1;
    }
}

 int
recog_48 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern0 (x3, 
E_V16QImode) != 0
              || !
#line 1267 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 728; /* mulv16qi3 */

        case E_V8HImode:
          if (pattern0 (x3, 
E_V8HImode) != 0
              || !
#line 1267 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 729; /* mulv8hi3 */

        case E_V4SImode:
          if (pattern0 (x3, 
E_V4SImode) != 0
              || !
#line 1267 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 730; /* mulv4si3 */

        case E_V2DImode:
          if (pattern0 (x3, 
E_V2DImode) != 0
              || !(
#line 1267 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 731; /* mulv2di3 */

        case E_V1TImode:
          if (pattern0 (x3, 
E_V1TImode) != 0
              || !(
#line 1267 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 732; /* mulv1ti3 */

        case E_TImode:
          if (pattern0 (x3, 
E_TImode) != 0
              || !(
#line 1267 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 733; /* multi3 */

        case E_V4SFmode:
          if (pattern0 (x3, 
E_V4SFmode) != 0
              || !(
#line 2006 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1247; /* mulv4sf3 */

        case E_V2DFmode:
          if (pattern0 (x3, 
E_V2DFmode) != 0
              || !
#line 2006 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1248; /* mulv2df3 */

        case E_V1TFmode:
          if (pattern0 (x3, 
E_V1TFmode) != 0
              || !(
#line 2006 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1249; /* mulv1tf3 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode)
            return -1;
          if (register_operand (operands[1], E_TFmode)
              && register_operand (operands[2], E_TFmode)
              && (
#line 2006 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1250; /* multf3_vr */
          if (!nonimmediate_operand (operands[1], E_TFmode)
              || !general_operand (operands[2], E_TFmode)
              || !(
#line 7580 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2337; /* multf3_fpr */

        case E_FPRX2mode:
          if (pattern175 (x3, 
E_FPRX2mode) != 0
              || !(
#line 7580 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2338; /* mulfprx23 */

        case E_DFmode:
          if (pattern175 (x3, 
E_DFmode) != 0
              || !
#line 7580 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2339; /* muldf3 */

        case E_SFmode:
          if (pattern175 (x3, 
E_SFmode) != 0
              || !
#line 7580 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2340; /* mulsf3 */

        case E_TDmode:
          if (pattern175 (x3, 
E_TDmode) != 0
              || !(
#line 7580 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2341; /* multd3 */

        case E_DDmode:
          if (pattern175 (x3, 
E_DDmode) != 0
              || !(
#line 7580 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2342; /* muldd3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_TImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != SIGN_EXTEND
          || GET_MODE (x5) != E_TImode
          || !register_operand (operands[0], E_TImode)
          || GET_MODE (x3) != E_TImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (nonimmediate_operand (operands[2], E_DImode)
          && register_operand (operands[1], E_DImode)
          && 
#line 7433 "../../gcc/config/s390/s390.md"
(TARGET_Z14))
        return 2327; /* mulditi3 */
      if (!register_operand (operands[2], E_DImode)
          || !nonimmediate_operand (operands[1], E_DImode)
          || !
#line 7446 "../../gcc/config/s390/s390.md"
(TARGET_Z14))
        return -1;
      return 2328; /* mulditi3_2 */

    case ZERO_EXTEND:
      if (pattern113 (x3, 
E_DImode, 
E_TImode) != 0
          || !
#line 782 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 2335; /* umulditi3 */

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 33)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      return recog_25 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != VEC_SELECT
          || GET_MODE (x7) != E_DImode)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != PARALLEL
          || XVECLEN (x8, 0) != 1)
        return -1;
      x9 = XVECEXP (x8, 0, 0);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x4, 0);
      operands[0] = x10;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x11 = XEXP (x7, 0);
      operands[1] = x11;
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      switch (GET_MODE (x2))
        {
        case E_CCSmode:
          if (GET_MODE (x3) != E_CCSmode
              || !
#line 2342 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1360; /* *vec_cmpv2di_lane0_ccs */

        case E_CCUmode:
          if (GET_MODE (x3) != E_CCUmode
              || !
#line 2342 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1361; /* *vec_cmpv2di_lane0_ccu */

        case E_CCZmode:
          if (GET_MODE (x3) != E_CCZmode
              || !
#line 2342 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1362; /* *vec_cmpv2di_lane0_ccz */

        default:
          return -1;
        }

    case AND:
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x10;
          x5 = XEXP (x4, 1);
          operands[1] = x5;
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (memory_operand (operands[0], E_QImode)
                  && immediate_operand (operands[1], E_QImode)
                  && immediate_operand (operands[2], E_QImode)
                  && 
#line 1020 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, s390_tm_ccmode (operands[1], operands[2], false))))
                return 1751; /* *tmqi_mem */
              break;

            case E_DImode:
              if (nonimmediate_operand (operands[0], E_DImode)
                  && immediate_operand (operands[1], E_DImode)
                  && immediate_operand (operands[2], E_DImode)
                  && 
#line 1034 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && s390_match_ccmode (insn, s390_tm_ccmode (operands[1], operands[2], true))
   && s390_single_part (operands[1], DImode, HImode, 0) >= 0))
                return 1752; /* *tmdi_reg */
              break;

            case E_SImode:
              if (nonimmediate_operand (operands[0], E_SImode)
                  && immediate_operand (operands[1], E_SImode)
                  && immediate_operand (operands[2], E_SImode)
                  && 
#line 1050 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, s390_tm_ccmode (operands[1], operands[2], true))
   && s390_single_part (operands[1], SImode, HImode, 0) >= 0))
                return 1753; /* *tmsi_reg */
              break;

            default:
              break;
            }
          if (pnum_clobbers == NULL)
            return -1;
          operands[1] = x10;
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          operands[2] = x5;
          switch (pattern154 (x4))
            {
            case 0:
              if (!
#line 7939 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && s390_match_ccmode(insn, CCTmode)
   /* Do not steal TM patterns.  */
   && s390_single_part (operands[2], DImode, HImode, 0) < 0))
                return -1;
              *pnum_clobbers = 1;
              return 2359; /* *anddi3_cconly */

            case 1:
              if (!
#line 8067 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)
   /* Do not steal TM patterns.  */
   && s390_single_part (operands[2], SImode, HImode, 0) < 0))
                return -1;
              *pnum_clobbers = 1;
              return 2370; /* *andsi3_cconly */

            default:
              return -1;
            }

        case NOT:
          if (pnum_clobbers == NULL)
            return -1;
          x7 = XEXP (x3, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (pattern134 (x4))
            {
            case 0:
              if (!(
#line 8602 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2395; /* *andcdi_cconly */

            case 1:
              if (!
#line 8602 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2397; /* *andcsi_cconly */

            case 2:
              if (!(
#line 8642 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2407; /* *nordi_cconly */

            case 3:
              if (!
#line 8642 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2409; /* *norsi_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      x7 = XEXP (x3, 1);
      operands[0] = x7;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !register_operand (operands[0], E_DImode)
                  || !
#line 1304 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSRmode) && TARGET_ZARCH))
                return -1;
              return 1777; /* *cmpdi_ccs_sign */

            case E_HImode:
              if (!memory_operand (operands[1], E_HImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !(
#line 1344 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSRmode) && TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1780; /* *cmpdi_ccs_signhi_rl */

                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !
#line 1344 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSRmode) && TARGET_Z10))
                    return -1;
                  return 1781; /* *cmpdi_ccs_signhi_rl */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_SImode:
          if (!memory_operand (operands[1], E_HImode)
              || !register_operand (operands[0], E_SImode)
              || !
#line 1320 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSRmode)))
            return -1;
          return 1778; /* *cmpsi_ccs_sign */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x7 = XEXP (x3, 1);
      operands[0] = x7;
      x10 = XEXP (x4, 0);
      if (GET_CODE (x10) == MEM
          && GET_MODE (x10) == E_HImode)
        {
          x12 = XEXP (x10, 0);
          operands[1] = x12;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (register_operand (operands[0], E_SImode))
                {
                  if (larl_operand (operands[1], E_SImode)
                      && 
#line 1382 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCURmode) && TARGET_Z10))
                    return 1784; /* *cmpsi_ccu_zerohi_rlsi */
                  if (larl_operand (operands[1], E_DImode)
                      && 
#line 1395 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCURmode) && TARGET_Z10))
                    return 1786; /* *cmpsi_ccu_zerohi_rldi */
                }
              break;

            case E_DImode:
              if (larl_operand (operands[1], E_DImode)
                  && register_operand (operands[0], E_DImode)
                  && (
#line 1395 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCURmode) && TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 1785; /* *cmpdi_ccu_zerohi_rldi */
              break;

            default:
              break;
            }
        }
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x4) != E_DImode)
        return -1;
      operands[1] = x10;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !
#line 1407 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCURmode) && TARGET_ZARCH))
        return -1;
      return 1787; /* *cmpdi_ccu_zero */

    case IOR:
      if (pnum_clobbers == NULL)
        return -1;
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case AND:
          if (GET_MODE (x10) != E_DImode)
            return -1;
          x5 = XEXP (x4, 1);
          if (GET_CODE (x5) != AND
              || GET_MODE (x5) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x12 = XEXP (x10, 0);
          operands[1] = x12;
          if (!nonimmediate_operand (operands[1], E_DImode))
            return -1;
          x13 = XEXP (x10, 1);
          operands[2] = x13;
          if (!contiguous_bitmask_operand (operands[2], E_DImode))
            return -1;
          x14 = XEXP (x5, 0);
          operands[3] = x14;
          if (!nonimmediate_operand (operands[3], E_DImode))
            return -1;
          x15 = XEXP (x5, 1);
          operands[4] = x15;
          if (!const_int_operand (operands[4], E_DImode)
              || !
#line 4540 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && s390_match_ccmode (insn, CCSmode)
   && INTVAL (operands[2]) == ~INTVAL (operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 1977; /* *insv_z10_noshift_cconly */

        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x10;
          x5 = XEXP (x4, 1);
          operands[2] = x5;
          switch (pattern154 (x4))
            {
            case 0:
              if (!
#line 8353 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode) && TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2381; /* *iordi3_cconly */

            case 1:
              if (!
#line 8435 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2384; /* *iorsi3_cconly */

            default:
              return -1;
            }

        case NOT:
          switch (pattern134 (x4))
            {
            case 0:
              if (!(
#line 8602 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2396; /* *orcdi_cconly */

            case 1:
              if (!
#line 8602 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2398; /* *orcsi_cconly */

            case 2:
              if (!(
#line 8642 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2408; /* *nanddi_cconly */

            case 3:
              if (!
#line 8642 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2410; /* *nandsi_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      return recog_26 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_27 (x1, insn, pnum_clobbers);

    case XOR:
      if (pnum_clobbers == NULL)
        return -1;
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      switch (pattern154 (x4))
        {
        case 0:
          if (!
#line 8778 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode) && TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2419; /* *xordi3_cconly */

        case 1:
          if (!
#line 8845 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2422; /* *xorsi3_cconly */

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x10 = XEXP (x4, 0);
      if (GET_CODE (x10) != XOR)
        return -1;
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x12 = XEXP (x10, 0);
      operands[1] = x12;
      x13 = XEXP (x10, 1);
      operands[2] = x13;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          if (GET_MODE (x10) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !register_operand (operands[2], E_DImode)
              || !(
#line 9056 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2430; /* *nxordi_cconly */

        case E_SImode:
          if (GET_MODE (x10) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_SImode)
              || !
#line 9056 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2431; /* *nxorsi_cconly */

        default:
          return -1;
        }

    case NEG:
      if (pnum_clobbers == NULL)
        return -1;
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          operands[1] = x10;
          x7 = XEXP (x3, 1);
          if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (GET_MODE (x4))
                {
                case E_DImode:
                  if (register_operand (operands[1], E_DImode)
                      && (
#line 9126 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    {
                      *pnum_clobbers = 1;
                      return 2438; /* *negdi2_cconly */
                    }
                  break;

                case E_SImode:
                  if (register_operand (operands[1], E_SImode)
                      && 
#line 9126 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                    {
                      *pnum_clobbers = 1;
                      return 2439; /* *negsi2_cconly */
                    }
                  break;

                default:
                  break;
                }
            }
          operands[2] = x7;
          switch (pattern135 (x4))
            {
            case 0:
              if (!(
#line 9247 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2447; /* *negtf2_cconly */

            case 1:
              if (!(
#line 9247 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2448; /* *negfprx22_cconly */

            case 2:
              if (!
#line 9247 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2449; /* *negdf2_cconly */

            case 3:
              if (!
#line 9247 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2450; /* *negsf2_cconly */

            default:
              return -1;
            }

        case ABS:
          x12 = XEXP (x10, 0);
          operands[1] = x12;
          x7 = XEXP (x3, 1);
          if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (GET_MODE (x4))
                {
                case E_DImode:
                  if (GET_MODE (x10) == E_DImode
                      && register_operand (operands[1], E_DImode)
                      && (
#line 9474 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    {
                      *pnum_clobbers = 1;
                      return 2491; /* *negabsdi2_cconly */
                    }
                  break;

                case E_SImode:
                  if (GET_MODE (x10) == E_SImode
                      && register_operand (operands[1], E_SImode)
                      && 
#line 9474 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                    {
                      *pnum_clobbers = 1;
                      return 2492; /* *negabssi2_cconly */
                    }
                  break;

                default:
                  break;
                }
            }
          operands[2] = x7;
          switch (GET_MODE (x4))
            {
            case E_TFmode:
              if (GET_MODE (x10) != E_TFmode
                  || !register_operand (operands[1], E_TFmode)
                  || !const0_operand (operands[2], E_TFmode)
                  || !(
#line 9511 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2499; /* *negabstf2_cconly */

            case E_FPRX2mode:
              if (GET_MODE (x10) != E_FPRX2mode
                  || !register_operand (operands[1], E_FPRX2mode)
                  || !const0_operand (operands[2], E_FPRX2mode)
                  || !(
#line 9511 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2500; /* *negabsfprx22_cconly */

            case E_DFmode:
              if (GET_MODE (x10) != E_DFmode
                  || !register_operand (operands[1], E_DFmode)
                  || !const0_operand (operands[2], E_DFmode)
                  || !
#line 9511 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2501; /* *negabsdf2_cconly */

            case E_SFmode:
              if (GET_MODE (x10) != E_SFmode
                  || !register_operand (operands[1], E_SFmode)
                  || !const0_operand (operands[2], E_SFmode)
                  || !
#line 9511 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2502; /* *negabssf2_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      if (pnum_clobbers == NULL)
        return -1;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      x7 = XEXP (x3, 1);
      if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (register_operand (operands[1], E_DImode)
                  && (
#line 9327 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                {
                  *pnum_clobbers = 1;
                  return 2465; /* *absdi2_cconly */
                }
              break;

            case E_SImode:
              if (register_operand (operands[1], E_SImode)
                  && 
#line 9327 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                {
                  *pnum_clobbers = 1;
                  return 2466; /* *abssi2_cconly */
                }
              break;

            default:
              break;
            }
        }
      operands[2] = x7;
      switch (pattern135 (x4))
        {
        case 0:
          if (!(
#line 9372 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2473; /* *abstf2_cconly */

        case 1:
          if (!(
#line 9372 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2474; /* *absfprx22_cconly */

        case 2:
          if (!
#line 9372 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2475; /* *absdf2_cconly */

        case 3:
          if (!
#line 9372 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2476; /* *abssf2_cconly */

        default:
          return -1;
        }

    case ASHIFTRT:
      if (pnum_clobbers == NULL)
        return -1;
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      if (!shift_count_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          if ((
#line 45 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 9734 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH)))
            {
              *pnum_clobbers = 1;
              return 2529; /* *ashrdi3_31_cconly */
            }
          if (!(
#line 45 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2532; /* *ashrdi3_cconly */

        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 45 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2535; /* *ashrsi3_cconly */

        default:
          return -1;
        }

    case POPCOUNT:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_DImode)
        return -1;
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 12102 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
        return -1;
      *pnum_clobbers = 1;
      return 2653; /* *popcountdi_z15_cconly */

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 3115 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1545; /* floatunsv2div2df2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SImode)
          || !(
#line 3115 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 101 "../../gcc/config/s390/vector.md"
(TARGET_VXE2)))
        return -1;
      return 1546; /* floatunsv4siv4sf2 */

    case E_DFmode:
      switch (pattern67 (x3, 
E_DFmode))
        {
        case 0:
          if (
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
            return 2094; /* *floatunsdidf2_z13 */
          if (!(
#line 5683 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || DFmode != DFmode || DImode != DImode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2100; /* *floatunsdidf2 */

        case 1:
          if (!
#line 5683 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || DFmode != DFmode || SImode != DImode)))
            return -1;
          return 2101; /* *floatunssidf2 */

        default:
          return -1;
        }

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          if ((
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT) && 
#line 767 "../../gcc/config/s390/s390.md"
(TARGET_VXE2)))
            return 2095; /* *floatunssisf2_z13 */
          if (!
#line 5683 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || SFmode != DFmode || SImode != DImode)))
            return -1;
          return 2103; /* *floatunssisf2 */

        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !(
#line 5683 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || SFmode != DFmode || DImode != DImode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2102; /* *floatunsdisf2 */

        default:
          return -1;
        }

    case E_TFmode:
      switch (pattern67 (x3, 
E_TFmode))
        {
        case 0:
          if (!(
#line 5683 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || TFmode != DFmode || DImode != DImode)) && (
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2096; /* *floatunsditf2 */

        case 1:
          if (!(
#line 5683 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || TFmode != DFmode || SImode != DImode)) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2097; /* *floatunssitf2 */

        default:
          return -1;
        }

    case E_FPRX2mode:
      switch (pattern67 (x3, 
E_FPRX2mode))
        {
        case 0:
          if (!(
#line 5683 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || FPRX2mode != DFmode || DImode != DImode)) && (
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2098; /* *floatunsdifprx22 */

        case 1:
          if (!(
#line 5683 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || FPRX2mode != DFmode || SImode != DImode)) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2099; /* *floatunssifprx22 */

        default:
          return -1;
        }

    case E_TDmode:
      switch (pattern67 (x3, 
E_TDmode))
        {
        case 0:
          if (!(
#line 5683 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || TDmode != DFmode || DImode != DImode)) && (
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2104; /* *floatunsditd2 */

        case 1:
          if (!(
#line 5683 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || TDmode != DFmode || SImode != DImode)) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2105; /* *floatunssitd2 */

        default:
          return -1;
        }

    case E_DDmode:
      switch (pattern67 (x3, 
E_DDmode))
        {
        case 0:
          if (!(
#line 5683 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || DDmode != DFmode || DImode != DImode)) && (
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2106; /* *floatunsdidd2 */

        case 1:
          if (!(
#line 5683 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || DDmode != DFmode || SImode != DImode)) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2107; /* *floatunssidd2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_88 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case ASHIFTRT:
      if (pattern148 (x1, 
NEG) != 0
          || !
#line 9094 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_match_ccmode (insn, CCAmode)))
        return -1;
      return 2434; /* *negdi2_sign_cc */

    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          res = recog_84 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[2] = x6;
      switch (pattern178 (x1, 
NEG))
        {
        case 0:
          if (!(
#line 9236 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2443; /* *negtf2_cc */

        case 1:
          if (!(
#line 9236 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2444; /* *negfprx22_cc */

        case 2:
          if (!
#line 9236 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 2445; /* *negdf2_cc */

        case 3:
          if (!
#line 9236 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 2446; /* *negsf2_cc */

        case 4:
          if (!(
#line 9247 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2447; /* *negtf2_cconly */

        case 5:
          if (!(
#line 9247 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2448; /* *negfprx22_cconly */

        case 6:
          if (!
#line 9247 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 2449; /* *negdf2_cconly */

        case 7:
          if (!
#line 9247 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 2450; /* *negsf2_cconly */

        default:
          return -1;
        }

    case ABS:
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case ASHIFTRT:
          if (GET_MODE (x7) != E_DImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != ASHIFT
              || GET_MODE (x8) != E_DImode)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != SUBREG
              || maybe_ne (SUBREG_BYTE (x9), 0)
              || GET_MODE (x9) != E_DImode)
            return -1;
          x10 = XEXP (x8, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x11 = XEXP (x7, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x6 = XEXP (x3, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x12 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x12) != SET)
            return -1;
          x13 = XEXP (x12, 1);
          if (pattern252 (x13, 
ABS, 
NEG) != 0)
            return -1;
          x14 = XEXP (x13, 0);
          x15 = XEXP (x14, 0);
          if (GET_CODE (x15) != SIGN_EXTEND
              || GET_MODE (x15) != E_DImode
              || GET_MODE (x4) != E_DImode
              || GET_MODE (x5) != E_DImode)
            return -1;
          x16 = XEXP (x9, 0);
          operands[1] = x16;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x17 = XEXP (x12, 0);
          operands[0] = x17;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x18 = XEXP (x15, 0);
          if (!rtx_equal_p (x18, operands[1])
              || !
#line 9441 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2487; /* *negabsdi2_sign_cc */

        case REG:
        case SUBREG:
          operands[1] = x7;
          x6 = XEXP (x3, 1);
          if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (pattern190 (x1, 
ABS, 
NEG))
                {
                case 0:
                  switch (GET_MODE (x4))
                    {
                    case E_DImode:
                      if (pattern260 (x1, 
E_DImode) == 0
                          && (
#line 9463 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return 2489; /* *negabsdi2_cc */
                      break;

                    case E_SImode:
                      if (pattern260 (x1, 
E_SImode) == 0
                          && 
#line 9463 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                        return 2490; /* *negabssi2_cc */
                      break;

                    default:
                      break;
                    }
                  break;

                case 1:
                  if (GET_MODE (x5) == E_DImode
                      && register_operand (operands[1], E_DImode)
                      && scratch_operand (operands[0], E_DImode)
                      && (
#line 9474 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2491; /* *negabsdi2_cconly */
                  break;

                case 2:
                  if (GET_MODE (x5) == E_SImode
                      && register_operand (operands[1], E_SImode)
                      && scratch_operand (operands[0], E_SImode)
                      && 
#line 9474 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                    return 2492; /* *negabssi2_cconly */
                  break;

                default:
                  break;
                }
            }
          operands[2] = x6;
          x12 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x12))
            {
            case SET:
              x13 = XEXP (x12, 1);
              if (GET_CODE (x13) != NEG)
                return -1;
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != ABS)
                return -1;
              x17 = XEXP (x12, 0);
              operands[0] = x17;
              x15 = XEXP (x14, 0);
              if (!rtx_equal_p (x15, operands[1]))
                return -1;
              switch (GET_MODE (x4))
                {
                case E_TFmode:
                  if (pattern261 (x1, 
E_TFmode) != 0
                      || !(
#line 9500 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                    return -1;
                  return 2495; /* *negabstf2_cc */

                case E_FPRX2mode:
                  if (pattern261 (x1, 
E_FPRX2mode) != 0
                      || !(
#line 9500 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                    return -1;
                  return 2496; /* *negabsfprx22_cc */

                case E_DFmode:
                  if (pattern261 (x1, 
E_DFmode) != 0
                      || !
#line 9500 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                    return -1;
                  return 2497; /* *negabsdf2_cc */

                case E_SFmode:
                  if (pattern261 (x1, 
E_SFmode) != 0
                      || !
#line 9500 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                    return -1;
                  return 2498; /* *negabssf2_cc */

                default:
                  return -1;
                }

            case CLOBBER:
              x17 = XEXP (x12, 0);
              operands[0] = x17;
              switch (GET_MODE (x4))
                {
                case E_TFmode:
                  if (pattern239 (x5, 
E_TFmode) != 0
                      || !(
#line 9511 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                    return -1;
                  return 2499; /* *negabstf2_cconly */

                case E_FPRX2mode:
                  if (pattern239 (x5, 
E_FPRX2mode) != 0
                      || !(
#line 9511 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                    return -1;
                  return 2500; /* *negabsfprx22_cconly */

                case E_DFmode:
                  if (pattern239 (x5, 
E_DFmode) != 0
                      || !
#line 9511 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                    return -1;
                  return 2501; /* *negabsdf2_cconly */

                case E_SFmode:
                  if (pattern239 (x5, 
E_SFmode) != 0
                      || !
#line 9511 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                    return -1;
                  return 2502; /* *negabssf2_cconly */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case AND:
      res = recog_96 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case REG:
    case SUBREG:
    case MEM:
      res = recog_97 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PLUS:
      res = recog_98 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MINUS:
      res = recog_99 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
      if (pattern38 (x1) == 0)
        {
          switch (GET_CODE (x3))
            {
            case SIGN_EXTEND:
              switch (pattern183 (x3))
                {
                case 0:
                  if (
#line 4211 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 1933; /* *cmpint_sign */
                  break;

                case 1:
                  if ((
#line 5112 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && !TARGET_LONG_DISPLACEMENT) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2035; /* *extendqidi2_short_displ */
                  break;

                case 2:
                  if (
#line 5112 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && !TARGET_LONG_DISPLACEMENT))
                    return 2036; /* *extendqisi2_short_displ */
                  break;

                default:
                  break;
                }
              break;

            case ZERO_EXTEND:
              if (GET_MODE (x3) == E_SImode
                  && register_operand (operands[0], E_SImode))
                {
                  x4 = XEXP (x3, 0);
                  operands[1] = x4;
                  if (s_operand (operands[1], E_HImode)
                      && 
#line 5297 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                    return 2052; /* *zero_extendhisi2_31 */
                }
              break;

            default:
              break;
            }
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (register_operand (operands[0], E_DImode))
                {
                  if (s390_alc_comparison (operands[1], E_DImode)
                      && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 2316; /* *sconddi */
                  if (s390_slb_comparison (operands[1], E_DImode)
                      && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 2318; /* *sconddi_neg */
                }
              break;

            case E_SImode:
              if (register_operand (operands[0], E_SImode))
                {
                  if (s390_alc_comparison (operands[1], E_SImode))
                    return 2317; /* *scondsi */
                  if (s390_slb_comparison (operands[1], E_SImode))
                    return 2319; /* *scondsi_neg */
                }
              break;

            default:
              break;
            }
        }
      break;

    case MULT:
      res = recog_100 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
      if (pnum_clobbers != NULL
          && XWINT (x3, 0) == 0L)
        {
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) == USE)
            {
              x6 = XEXP (x2, 0);
              operands[0] = x6;
              if (memory_operand (operands[0], E_BLKmode))
                {
                  x7 = XEXP (x5, 0);
                  operands[1] = x7;
                  if (const_int_operand (operands[1], E_VOIDmode)
                      && 
#line 9005 "../../gcc/config/s390/s390.md"
(INTVAL (operands[1]) >= 1 && INTVAL (operands[1]) <= 256))
                    {
                      *pnum_clobbers = 1;
                      return 2427; /* *xc_zero */
                    }
                }
            }
        }
      break;

    default:
      break;
    }
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x2, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XEXP (x5, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[1] = x3;
      if (!address_operand (operands[1], E_QImode)
          || !
#line 2602 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
        return -1;
      return 1870; /* force_la_31 */

    case PC:
      x7 = XEXP (x5, 0);
      if (GET_CODE (x7) != LABEL_REF)
        return -1;
      operands[0] = x3;
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (address_operand (operands[0], E_VOIDmode)
          && 
#line 10554 "../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK))
        return 2569; /* *casesi_jump */
      if (register_operand (operands[0], E_DImode)
          && (
#line 10573 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        return 2570; /* casesi_jump_via_thunkdi_z10 */
      if (register_operand (operands[0], E_SImode)
          && (
#line 10573 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return 2571; /* casesi_jump_via_thunksi_z10 */
      if (pnum_clobbers == NULL)
        return -1;
      if (register_operand (operands[0], E_DImode)
          && (
#line 10591 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 2572; /* casesi_jump_via_thunkdi */
        }
      if (!register_operand (operands[0], E_SImode)
          || !(
#line 10591 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 2573; /* casesi_jump_via_thunksi */

    default:
      return -1;
    }
}

 int
recog_114 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x3))
        {
        case CLOBBER:
          x4 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x4) != SET)
            return -1;
          x5 = XEXP (x4, 1);
          if (GET_CODE (x5) != COMPARE
              || GET_MODE (x5) != E_CCUmode)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_BLKmode)
            return -1;
          x7 = XEXP (x5, 1);
          if (GET_CODE (x7) != MEM
              || GET_MODE (x7) != E_BLKmode)
            return -1;
          x8 = XEXP (x4, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 33
              || GET_MODE (x8) != E_CCUmode)
            return -1;
          x9 = XVECEXP (x1, 0, 3);
          if (pattern97 (x9, 
E_SImode, 
0, 
USE) != 0)
            return -1;
          x10 = XEXP (x2, 0);
          operands[0] = x10;
          x11 = XEXP (x3, 0);
          operands[1] = x11;
          x12 = XEXP (x6, 0);
          operands[2] = x12;
          x13 = XEXP (x7, 0);
          operands[3] = x13;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern291 (
E_DImode) != 0
                  || !
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 1900; /* *cmpstrdi */

            case E_SImode:
              if (pattern291 (
E_SImode) != 0
                  || !
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 1901; /* *cmpstrsi */

            default:
              return -1;
            }

        case SET:
          x11 = XEXP (x3, 0);
          if (GET_CODE (x11) != MEM
              || GET_MODE (x11) != E_BLKmode)
            return -1;
          x9 = XVECEXP (x1, 0, 3);
          if (pattern97 (x9, 
E_CCmode, 
33, 
CLOBBER) != 0)
            return -1;
          switch (pattern126 (x1))
            {
            case 0:
              if (!
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 1902; /* *movstr */

            case 1:
              if (!
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 1903; /* *movstr */

            case 2:
              if (!(
#line 3958 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1920; /* *setmem_long */

            case 3:
              if (!(
#line 3958 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1921; /* *setmem_long */

            case 4:
              if (!
#line 3986 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
                return -1;
              return 1924; /* *setmem_long_31z */

            case 5:
              if (!(
#line 3971 "../../gcc/config/s390/s390.md"
((TARGET_64BIT || !TARGET_ZARCH)) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1922; /* *setmem_long_and */

            case 6:
              if (!(
#line 3971 "../../gcc/config/s390/s390.md"
((TARGET_64BIT || !TARGET_ZARCH)) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1923; /* *setmem_long_and */

            case 7:
              if (!
#line 3998 "../../gcc/config/s390/s390.md"
((!TARGET_64BIT && TARGET_ZARCH)))
                return -1;
              return 1925; /* *setmem_long_and_31z */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x9 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x9) != CLOBBER)
        return -1;
      x14 = XEXP (x2, 1);
      switch (GET_CODE (x14))
        {
        case SUBREG:
        case MEM:
          if (pattern74 (x1) != 0)
            return -1;
          switch (pattern193 (x1))
            {
            case 0:
              if (!(
#line 3594 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1904; /* *cpymem_short */

            case 1:
              if (!(
#line 3594 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1905; /* *cpymem_short */

            default:
              return -1;
            }

        case COMPARE:
          if (pattern73 (x1) != 0)
            return -1;
          switch (pattern193 (x1))
            {
            case 0:
              if (!(
#line 4043 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1926; /* *cmpmem_short */

            case 1:
              if (!(
#line 4043 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1927; /* *cmpmem_short */

            default:
              return -1;
            }

        case FLOAT_TRUNCATE:
          switch (pattern75 (x1))
            {
            case 0:
              if (!(
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2160; /* *trunctftd2 */

            case 1:
              if (!(
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2161; /* *truncfprx2td2 */

            case 2:
              if (!
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2162; /* *truncdftd2 */

            case 3:
              if (!
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2163; /* *truncsftd2 */

            case 4:
              if (!(
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2164; /* *trunctfdd2 */

            case 5:
              if (!(
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2165; /* *truncfprx2dd2 */

            case 6:
              if (!
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2166; /* *truncdfdd2 */

            case 7:
              if (!
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2167; /* *truncsfdd2 */

            case 8:
              if (!(
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2168; /* *trunctfsd2 */

            case 9:
              if (!(
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2169; /* *truncfprx2sd2 */

            case 10:
              if (!
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2170; /* *truncdfsd2 */

            case 11:
              if (!
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2171; /* *truncsfsd2 */

            case 12:
              if (!(
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2172; /* *trunctdtf2 */

            case 13:
              if (!(
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2176; /* *truncddtf2 */

            case 14:
              if (!(
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2180; /* *truncsdtf2 */

            case 15:
              if (!(
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2173; /* *trunctdfprx22 */

            case 16:
              if (!(
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2177; /* *truncddfprx22 */

            case 17:
              if (!(
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2181; /* *truncsdfprx22 */

            case 18:
              if (!
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2174; /* *trunctddf2 */

            case 19:
              if (!
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2178; /* *truncdddf2 */

            case 20:
              if (!
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2182; /* *truncsddf2 */

            case 21:
              if (!
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2175; /* *trunctdsf2 */

            case 22:
              if (!
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2179; /* *truncddsf2 */

            case 23:
              if (!
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2183; /* *truncsdsf2 */

            default:
              return -1;
            }

        case FLOAT_EXTEND:
          switch (pattern75 (x1))
            {
            case 0:
              if (!(
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2184; /* *extendtftd2 */

            case 1:
              if (!(
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2185; /* *extendfprx2td2 */

            case 2:
              if (!
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2186; /* *extenddftd2 */

            case 3:
              if (!
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2187; /* *extendsftd2 */

            case 4:
              if (!(
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2188; /* *extendtfdd2 */

            case 5:
              if (!(
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2189; /* *extendfprx2dd2 */

            case 6:
              if (!
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2190; /* *extenddfdd2 */

            case 7:
              if (!
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2191; /* *extendsfdd2 */

            case 8:
              if (!(
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2192; /* *extendtfsd2 */

            case 9:
              if (!(
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2193; /* *extendfprx2sd2 */

            case 10:
              if (!
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2194; /* *extenddfsd2 */

            case 11:
              if (!
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2195; /* *extendsfsd2 */

            case 12:
              if (!(
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2196; /* *extendtdtf2 */

            case 13:
              if (!(
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2200; /* *extendddtf2 */

            case 14:
              if (!(
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2204; /* *extendsdtf2 */

            case 15:
              if (!(
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2197; /* *extendtdfprx22 */

            case 16:
              if (!(
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2201; /* *extendddfprx22 */

            case 17:
              if (!(
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2205; /* *extendsdfprx22 */

            case 18:
              if (!
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2198; /* *extendtddf2 */

            case 19:
              if (!
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2202; /* *extenddddf2 */

            case 20:
              if (!
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2206; /* *extendsddf2 */

            case 21:
              if (!
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2199; /* *extendtdsf2 */

            case 22:
              if (!
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2203; /* *extendddsf2 */

            case 23:
              if (!
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2207; /* *extendsdsf2 */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          switch (pattern78 (x1))
            {
            case 0:
              if (!
#line 10071 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2553; /* *brxg_64bit */

            case 1:
              if (!
#line 10157 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                return -1;
              return 2555; /* *brx_31bit */

            case 2:
              if (!
#line 10114 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2554; /* *brx_64bit */

            case 3:
              return 2556; /* doloop_si64 */

            case 4:
              if (!
#line 10255 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2557; /* doloop_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern9 (x1))
    {
    case 0:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_151 (insn, operands);

    case 1:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_160 (insn, operands);

    case 2:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_169 (insn, operands);

    case 3:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_178 (insn, operands);

    case 4:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_187 (insn, operands);

    case 5:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_196 (insn, operands);

    case 6:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_205 (insn, operands);

    case 7:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_214 (insn, operands);

    case 8:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_223 (insn, operands);

    case 9:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_232 (insn, operands);

    case 10:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_241 (insn, operands);

    case 11:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_250 (insn, operands);

    case 12:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_259 (insn, operands);

    case 13:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_268 (insn, operands);

    case 14:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_277 (insn, operands);

    case 15:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_286 (insn, operands);

    case 16:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_152 (insn, operands);

    case 17:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_161 (insn, operands);

    case 18:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_170 (insn, operands);

    case 19:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_179 (insn, operands);

    case 20:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_188 (insn, operands);

    case 21:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_197 (insn, operands);

    case 22:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_206 (insn, operands);

    case 23:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_215 (insn, operands);

    case 24:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_224 (insn, operands);

    case 25:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_233 (insn, operands);

    case 26:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_242 (insn, operands);

    case 27:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_251 (insn, operands);

    case 28:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_260 (insn, operands);

    case 29:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_269 (insn, operands);

    case 30:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_278 (insn, operands);

    case 31:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_287 (insn, operands);

    case 32:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_153 (insn, operands);

    case 33:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_162 (insn, operands);

    case 34:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_171 (insn, operands);

    case 35:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_180 (insn, operands);

    case 36:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_189 (insn, operands);

    case 37:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_198 (insn, operands);

    case 38:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_207 (insn, operands);

    case 39:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_216 (insn, operands);

    case 40:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_225 (insn, operands);

    case 41:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_234 (insn, operands);

    case 42:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_243 (insn, operands);

    case 43:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_252 (insn, operands);

    case 44:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_261 (insn, operands);

    case 45:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_270 (insn, operands);

    case 46:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_279 (insn, operands);

    case 47:
      if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_288 (insn, operands);

    default:
      return NULL;
    }
}
