/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2DFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V2DFmode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V2DFmode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V2DFmode))
    return -1;
  return 0;
}

int
pattern12 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  if (!register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern16 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern19 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern21 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern25 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[1] = x5;
  return 0;
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern8 (x1, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern8 (x1, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern8 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern8 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern8 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern8 (x1, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern8 (x1, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern8 (x1, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern8 (x1, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern8 (x1, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern8 (x1, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern8 (x1, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern8 (x1, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern8 (x1, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V1TImode:
      if (pattern8 (x1, 
E_V1TImode) != 0)
        return -1;
      return 14;

    case E_TImode:
      if (pattern8 (x1, 
E_TImode) != 0)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern45 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  if (!cc_reg_operand (operands[2], E_VOIDmode))
    return -1;
  x3 = XEXP (x1, 1);
  operands[3] = x3;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !s390_comparison (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !s390_comparison (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern53 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern58 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_mask_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      return pattern19 (x1, 
E_V4SFmode); /* [-1, 0] */

    case E_V2DFmode:
      if (pattern19 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 1;

    case E_V1TFmode:
      if (pattern19 (x1, 
E_V1TFmode) != 0)
        return -1;
      return 2;

    case E_TFmode:
      if (pattern19 (x1, 
E_TFmode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern64 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern68 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != i1
      || GET_MODE (x3) != E_CCRAWmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCRAWmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XVECEXP (x7, 0, 0);
  operands[1] = x8;
  x9 = XVECEXP (x7, 0, 1);
  operands[2] = x9;
  x10 = XVECEXP (x7, 0, 2);
  operands[3] = x10;
  return 0;
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != PLUS)
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 33
      || GET_MODE (x11) != E_CCmode)
    return -1;
  x12 = XEXP (x4, 0);
  operands[0] = x12;
  x13 = XEXP (x3, 0);
  switch (GET_CODE (x13))
    {
    case GT:
    case LE:
      operands[5] = x13;
      if (!s390_brx_operator (operands[5], E_VOIDmode))
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != PLUS)
        return -1;
      x15 = XEXP (x14, 1);
      if (GET_CODE (x15) != SUBREG)
        return -1;
      x16 = XEXP (x13, 1);
      if (GET_CODE (x16) != SUBREG)
        return -1;
      x17 = XEXP (x8, 1);
      if (GET_CODE (x17) != SUBREG)
        return -1;
      x18 = XEXP (x14, 0);
      operands[1] = x18;
      x19 = XEXP (x15, 0);
      operands[2] = x19;
      x20 = XEXP (x7, 0);
      operands[3] = x20;
      x21 = XEXP (x9, 0);
      operands[4] = x21;
      x22 = XEXP (x16, 0);
      if (!rtx_equal_p (x22, operands[2]))
        return -1;
      x23 = XEXP (x8, 0);
      if (!rtx_equal_p (x23, operands[1]))
        return -1;
      x24 = XEXP (x17, 0);
      if (!rtx_equal_p (x24, operands[2]))
        return -1;
      switch (SUBREG_BYTE (x15))
        {
        case 0:
          if (maybe_ne (SUBREG_BYTE (x17), 0))
            return -1;
          switch (SUBREG_BYTE (x16))
            {
            case 8:
              return pattern76 (x1, 
E_DImode, 
E_TImode); /* [-1, 0] */

            case 4:
              if (pattern76 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 1;

            default:
              return -1;
            }

        case 4:
          if (GET_MODE (x15) != E_SImode
              || maybe_ne (SUBREG_BYTE (x16), 12)
              || GET_MODE (x16) != E_SImode
              || maybe_ne (SUBREG_BYTE (x17), 4)
              || GET_MODE (x17) != E_SImode
              || GET_MODE (x14) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_TImode)
              || !nonimmediate_operand (operands[3], E_SImode)
              || GET_MODE (x8) != E_SImode
              || !scratch_operand (operands[4], E_SImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case NE:
      x16 = XEXP (x13, 1);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x17 = XEXP (x8, 1);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      x14 = XEXP (x13, 0);
      operands[1] = x14;
      x20 = XEXP (x7, 0);
      operands[2] = x20;
      x21 = XEXP (x9, 0);
      operands[3] = x21;
      x23 = XEXP (x8, 0);
      if (!rtx_equal_p (x23, operands[1]))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (pattern77 (x8, 
E_SImode) != 0)
            return -1;
          return 3;

        case E_DImode:
          if (pattern77 (x8, 
E_DImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern129 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  return 0;
}

int
pattern139 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern147 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x7))
    {
    case SET:
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != i1)
        return -1;
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XEXP (x8, 1);
      if (!rtx_equal_p (x11, operands[2]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          return pattern145 (x8, 
E_DImode); /* [-1, 0] */

        case E_SImode:
          if (pattern145 (x8, 
E_SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case CLOBBER:
      res = pattern146 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern157 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern64 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern64 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern163 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!nonimmediate_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !nonimmediate_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!nonimmediate_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !nonimmediate_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!nonimmediate_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !nonimmediate_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    case E_V2DFmode:
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !nonimmediate_operand (operands[1], E_V2DFmode))
        return -1;
      return 4;

    case E_V1TImode:
      if (!nonimmediate_operand (operands[0], E_V1TImode)
          || GET_MODE (x1) != E_V1TImode
          || !nonimmediate_operand (operands[1], E_V1TImode))
        return -1;
      return 5;

    case E_V1TFmode:
      if (!nonimmediate_operand (operands[0], E_V1TFmode)
          || GET_MODE (x1) != E_V1TFmode
          || !nonimmediate_operand (operands[1], E_V1TFmode))
        return -1;
      return 6;

    case E_TImode:
      if (!nonimmediate_operand (operands[0], E_TImode)
          || GET_MODE (x1) != E_TImode
          || !nonimmediate_operand (operands[1], E_TImode))
        return -1;
      return 7;

    case E_TFmode:
      if (!nonimmediate_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !nonimmediate_operand (operands[1], E_TFmode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern191 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !scratch_operand (operands[0], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !scratch_operand (operands[0], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern200 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !immediate_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern207 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern218 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern223 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern231 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 5
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCRAWmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  operands[1] = x8;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x9 = XEXP (x6, 1);
  x10 = XEXP (x9, 0);
  operands[2] = x10;
  x11 = XEXP (x2, 0);
  operands[3] = x11;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern245 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1)
      || !contiguous_bitmask_nowrap_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern254 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  if (!const0_operand (operands[3], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern265 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!nonimmediate_operand (operands[0], E_V8HImode))
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!nonimmediate_operand (operands[1], E_V8HImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_V2DImode))
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_V4SImode))
    return -1;
  return 0;
}

int
pattern277 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern287 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || pattern284 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern294 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pattern25 (x1, 
E_CCRAWmode) != 0)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !register_operand (operands[1], E_V16QImode)
          || !
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 347; /* *vec_test_maskv16qi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 348; /* *vec_test_maskv8hi */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 349; /* *vec_test_maskv4si */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 350; /* *vec_test_maskv2di */

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !register_operand (operands[1], E_V1TImode)
          || !
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 351; /* *vec_test_maskv1ti */

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || !register_operand (operands[1], E_TImode)
          || !
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 352; /* *vec_test_maskti */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 353; /* *vec_test_maskv2df */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SImode)
          || !(
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 34 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 354; /* *vec_test_maskv4sf */

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || !register_operand (operands[1], E_V1TImode)
          || !(
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 34 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 355; /* *vec_test_maskv1tf */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !register_operand (operands[1], E_TImode)
          || !(
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 35 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 356; /* *vec_test_masktf */

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern24 (x1))
    {
    case 0:
      if (!
#line 1711 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1109; /* *vec_slbv16qi */

    case 1:
      if (!
#line 1711 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1110; /* *vec_slbv8hi */

    case 2:
      if (!
#line 1711 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1111; /* *vec_slbv4si */

    case 3:
      if (!
#line 1711 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1112; /* *vec_slbv2di */

    case 4:
      if (!
#line 1711 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1113; /* *vec_slbv1ti */

    case 5:
      if (!
#line 1711 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1114; /* *vec_slbti */

    case 6:
      if (!
#line 1711 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1115; /* *vec_slbv4sf */

    case 7:
      if (!
#line 1711 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1116; /* *vec_slbv2df */

    case 8:
      if (!
#line 1711 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1117; /* *vec_slbv1tf */

    case 9:
      if (!
#line 1711 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1118; /* *vec_slbtf */

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case PARALLEL:
      switch (XVECLEN (x3, 0))
        {
        case 1:
          x4 = XEXP (x1, 0);
          if (GET_CODE (x4) == MEM)
            {
              res = recog_19 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[0] = x4;
          x5 = XEXP (x2, 0);
          operands[1] = x5;
          x6 = XVECEXP (x3, 0, 0);
          operands[2] = x6;
          if (!nonmemory_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!nonimmediate_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V1QImode:
                  if (!nonmemory_operand (operands[1], E_V1QImode)
                      || !
#line 633 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 582; /* *vec_extractv1qi */

                case E_V2QImode:
                  if (!nonmemory_operand (operands[1], E_V2QImode)
                      || !
#line 633 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 583; /* *vec_extractv2qi */

                case E_V4QImode:
                  if (!nonmemory_operand (operands[1], E_V4QImode)
                      || !
#line 633 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 584; /* *vec_extractv4qi */

                case E_V8QImode:
                  if (!nonmemory_operand (operands[1], E_V8QImode)
                      || !
#line 633 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 585; /* *vec_extractv8qi */

                case E_V16QImode:
                  if (!nonmemory_operand (operands[1], E_V16QImode)
                      || !
#line 633 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 586; /* *vec_extractv16qi */

                default:
                  return -1;
                }

            case E_HImode:
              if (!nonimmediate_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V1HImode:
                  if (!nonmemory_operand (operands[1], E_V1HImode)
                      || !
#line 633 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 587; /* *vec_extractv1hi */

                case E_V2HImode:
                  if (!nonmemory_operand (operands[1], E_V2HImode)
                      || !
#line 633 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 588; /* *vec_extractv2hi */

                case E_V4HImode:
                  if (!nonmemory_operand (operands[1], E_V4HImode)
                      || !
#line 633 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 589; /* *vec_extractv4hi */

                case E_V8HImode:
                  if (!nonmemory_operand (operands[1], E_V8HImode)
                      || !
#line 633 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 590; /* *vec_extractv8hi */

                default:
                  return -1;
                }

            case E_SImode:
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V1SImode:
                  if (!nonmemory_operand (operands[1], E_V1SImode)
                      || !
#line 633 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 591; /* *vec_extractv1si */

                case E_V2SImode:
                  if (!nonmemory_operand (operands[1], E_V2SImode)
                      || !
#line 633 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 592; /* *vec_extractv2si */

                case E_V4SImode:
                  if (!nonmemory_operand (operands[1], E_V4SImode)
                      || !
#line 633 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 593; /* *vec_extractv4si */

                default:
                  return -1;
                }

            case E_DImode:
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V1DImode:
                  if (!nonmemory_operand (operands[1], E_V1DImode)
                      || !
#line 633 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 594; /* *vec_extractv1di */

                case E_V2DImode:
                  if (!nonmemory_operand (operands[1], E_V2DImode)
                      || !
#line 633 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 595; /* *vec_extractv2di */

                default:
                  return -1;
                }

            case E_SFmode:
              if (!nonimmediate_operand (operands[0], E_SFmode)
                  || GET_MODE (x2) != E_SFmode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V2SFmode:
                  if (!nonmemory_operand (operands[1], E_V2SFmode)
                      || !
#line 650 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 596; /* *vec_extractv2sf */

                case E_V4SFmode:
                  if (!nonmemory_operand (operands[1], E_V4SFmode)
                      || !
#line 650 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 597; /* *vec_extractv4sf */

                default:
                  return -1;
                }

            case E_DFmode:
              if (!nonimmediate_operand (operands[0], E_DFmode)
                  || GET_MODE (x2) != E_DFmode
                  || !nonmemory_operand (operands[1], E_V2DFmode)
                  || !
#line 650 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 598; /* *vec_extractv2df */

            default:
              return -1;
            }

        case 8:
          if (pattern59 (x3, pnum_clobbers, 
4, 
5, 
6, 
7) != 0)
            return -1;
          x7 = XVECEXP (x3, 0, 4);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x8 = XVECEXP (x3, 0, 5);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x9 = XVECEXP (x3, 0, 6);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x10 = XVECEXP (x3, 0, 7);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!nonimmediate_operand (operands[0], E_V8HImode)
              || GET_MODE (x2) != E_V8HImode)
            return -1;
          x5 = XEXP (x2, 0);
          operands[1] = x5;
          if (!nonimmediate_operand (operands[1], E_V8HImode)
              || !
#line 1159 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          *pnum_clobbers = 2;
          return 691; /* eltswapv8hi */

        case 4:
          if (pattern59 (x3, pnum_clobbers, 
0, 
1, 
2, 
3) != 0)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          x5 = XEXP (x2, 0);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (!nonimmediate_operand (operands[0], E_V4SImode)
                  || GET_MODE (x2) != E_V4SImode
                  || !nonimmediate_operand (operands[1], E_V4SImode)
                  || !
#line 1198 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 692; /* eltswapv4si */

            case E_V4SFmode:
              if (!nonimmediate_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x2) != E_V4SFmode
                  || !nonimmediate_operand (operands[1], E_V4SFmode)
                  || !
#line 1198 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 693; /* eltswapv4sf */

            default:
              return -1;
            }

        case 2:
          x6 = XVECEXP (x3, 0, 0);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x11 = XVECEXP (x3, 0, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          x5 = XEXP (x2, 0);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (!nonimmediate_operand (operands[0], E_V2DImode)
                  || GET_MODE (x2) != E_V2DImode
                  || !nonimmediate_operand (operands[1], E_V2DImode)
                  || !
#line 1228 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 694; /* eltswapv2di */

            case E_V2DFmode:
              if (!nonimmediate_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x2) != E_V2DFmode
                  || !nonimmediate_operand (operands[1], E_V2DFmode)
                  || !
#line 1228 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 695; /* eltswapv2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x12 = XEXP (x3, 1);
      if (GET_CODE (x12) != PARALLEL
          || XVECLEN (x12, 0) != 1)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      x13 = XEXP (x3, 0);
      operands[2] = x13;
      if (!nonmemory_operand (operands[2], E_SImode))
        return -1;
      x14 = XVECEXP (x12, 0, 0);
      operands[3] = x14;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V1QImode:
              if (!register_operand (operands[1], E_V1QImode)
                  || !
#line 698 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 599; /* *vec_extractv1qi_plus */

            case E_V2QImode:
              if (!register_operand (operands[1], E_V2QImode)
                  || !
#line 698 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 600; /* *vec_extractv2qi_plus */

            case E_V4QImode:
              if (!register_operand (operands[1], E_V4QImode)
                  || !
#line 698 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 601; /* *vec_extractv4qi_plus */

            case E_V8QImode:
              if (!register_operand (operands[1], E_V8QImode)
                  || !
#line 698 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 602; /* *vec_extractv8qi_plus */

            case E_V16QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !
#line 698 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 603; /* *vec_extractv16qi_plus */

            default:
              return -1;
            }

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V1HImode:
              if (!register_operand (operands[1], E_V1HImode)
                  || !
#line 698 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 604; /* *vec_extractv1hi_plus */

            case E_V2HImode:
              if (!register_operand (operands[1], E_V2HImode)
                  || !
#line 698 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 605; /* *vec_extractv2hi_plus */

            case E_V4HImode:
              if (!register_operand (operands[1], E_V4HImode)
                  || !
#line 698 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 606; /* *vec_extractv4hi_plus */

            case E_V8HImode:
              if (!register_operand (operands[1], E_V8HImode)
                  || !
#line 698 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 607; /* *vec_extractv8hi_plus */

            default:
              return -1;
            }

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V1SImode:
              if (!register_operand (operands[1], E_V1SImode)
                  || !
#line 698 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 608; /* *vec_extractv1si_plus */

            case E_V2SImode:
              if (!register_operand (operands[1], E_V2SImode)
                  || !
#line 698 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 609; /* *vec_extractv2si_plus */

            case E_V4SImode:
              if (!register_operand (operands[1], E_V4SImode)
                  || !
#line 698 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 610; /* *vec_extractv4si_plus */

            default:
              return -1;
            }

        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V1DImode:
              if (!register_operand (operands[1], E_V1DImode)
                  || !
#line 698 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 611; /* *vec_extractv1di_plus */

            case E_V2DImode:
              if (!register_operand (operands[1], E_V2DImode)
                  || !
#line 698 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 612; /* *vec_extractv2di_plus */

            default:
              return -1;
            }

        case E_SFmode:
          if (!nonimmediate_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V1SFmode:
              if (!register_operand (operands[1], E_V1SFmode)
                  || !
#line 698 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 613; /* *vec_extractv1sf_plus */

            case E_V2SFmode:
              if (!register_operand (operands[1], E_V2SFmode)
                  || !
#line 698 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 614; /* *vec_extractv2sf_plus */

            case E_V4SFmode:
              if (!register_operand (operands[1], E_V4SFmode)
                  || !
#line 698 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 615; /* *vec_extractv4sf_plus */

            default:
              return -1;
            }

        case E_DFmode:
          if (!nonimmediate_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V1DFmode:
              if (!register_operand (operands[1], E_V1DFmode)
                  || !
#line 698 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 616; /* *vec_extractv1df_plus */

            case E_V2DFmode:
              if (!register_operand (operands[1], E_V2DFmode)
                  || !
#line 698 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 617; /* *vec_extractv2df_plus */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (pattern13 (x1))
    {
    case 0:
      if (!
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1307; /* *vec_cmpgtv1qiv1qi_nocc */

    case 1:
      if (!
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1310; /* *vec_cmpgtv2qiv2qi_nocc */

    case 2:
      if (!
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1313; /* *vec_cmpgtv4qiv4qi_nocc */

    case 3:
      if (!
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1316; /* *vec_cmpgtv8qiv8qi_nocc */

    case 4:
      if (!
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1319; /* *vec_cmpgtv16qiv16qi_nocc */

    case 5:
      if (!
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1322; /* *vec_cmpgtv1hiv1hi_nocc */

    case 6:
      if (!
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1325; /* *vec_cmpgtv2hiv2hi_nocc */

    case 7:
      if (!
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1328; /* *vec_cmpgtv4hiv4hi_nocc */

    case 8:
      if (!
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1331; /* *vec_cmpgtv8hiv8hi_nocc */

    case 9:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V1SImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V1SImode)
              && 
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1334; /* *vec_cmpgtv1siv1si_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V1SFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V1SFmode))
        return -1;
      if (
#line 2420 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1394; /* *vec_cmpgtv1sf_signaling_nocc */
      if (!(
#line 2428 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1401; /* *vec_cmpgtv1sf_signaling_finite_nocc */

    case 10:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V2SImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V2SImode)
              && 
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1337; /* *vec_cmpgtv2siv2si_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V2SFmode))
        return -1;
      if (
#line 2420 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1395; /* *vec_cmpgtv2sf_signaling_nocc */
      if (!(
#line 2428 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1402; /* *vec_cmpgtv2sf_signaling_finite_nocc */

    case 11:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V4SImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V4SImode)
              && 
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1340; /* *vec_cmpgtv4siv4si_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V4SFmode))
        return -1;
      if (
#line 2420 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1396; /* *vec_cmpgtv4sf_signaling_nocc */
      if (!(
#line 2428 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1403; /* *vec_cmpgtv4sf_signaling_finite_nocc */

    case 12:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V1DImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V1DImode)
              && 
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1343; /* *vec_cmpgtv1div1di_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V1DFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V1DFmode))
        return -1;
      if (
#line 2420 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1397; /* *vec_cmpgtv1df_signaling_nocc */
      if (!
#line 2428 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK))
        return -1;
      return 1404; /* *vec_cmpgtv1df_signaling_finite_nocc */

    case 13:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V2DImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V2DImode)
              && 
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1346; /* *vec_cmpgtv2div2di_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2DFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V2DFmode))
        return -1;
      if (
#line 2420 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1398; /* *vec_cmpgtv2df_signaling_nocc */
      if (!
#line 2428 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK))
        return -1;
      return 1405; /* *vec_cmpgtv2df_signaling_finite_nocc */

    case 14:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V1TImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V1TImode)
              && (
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return 1349; /* *vec_cmpgtv1tiv1ti_nocc */
        }
      operands[0] = x2;
      switch (pattern110 (x3))
        {
        case 0:
          if (!
#line 2271 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3))
            return -1;
          return 1356; /* *vec_cmpgtv1tiv1ti_nocc_emu */

        case 1:
          if (
#line 2420 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return 1399; /* *vec_cmpgtv1tf_signaling_nocc */
          if (!(
#line 2428 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1406; /* *vec_cmpgtv1tf_signaling_finite_nocc */

        default:
          return -1;
        }

    case 15:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_TImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_TImode)
              && (
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return 1352; /* *vec_cmpgttiti_nocc */
        }
      operands[0] = x2;
      switch (pattern111 (x3))
        {
        case 0:
          if (!
#line 2271 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3))
            return -1;
          return 1357; /* *vec_cmpgttiti_nocc_emu */

        case 1:
          if (
#line 2420 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return 1400; /* *vec_cmpgttf_signaling_nocc */
          if (!(
#line 2428 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1407; /* *vec_cmpgttf_signaling_finite_nocc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_51 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (SUBREG_BYTE (x3))
    {
    case 0:
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case ROTATE:
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          if (!contiguous_bitmask_operand (operands[3], E_DImode))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !const_int_operand (operands[2], E_SImode))
                return -1;
              if (
#line 4379 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1950; /* *risbgn_and_subregdi_rotr */
              if (pnum_clobbers != NULL
                  && 
#line 4379 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                {
                  *pnum_clobbers = 1;
                  return 1951; /* *risbg_and_subregdi_rotr */
                }
              if (
#line 4392 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return 1956; /* *risbgn_and_subregdi_rotl */
              if (pnum_clobbers == NULL
                  || !
#line 4392 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              *pnum_clobbers = 1;
              return 1957; /* *risbg_and_subregdi_rotl */

            case E_HImode:
              if (!register_operand (operands[1], E_HImode)
                  || !const_int_operand (operands[2], E_HImode))
                return -1;
              if (
#line 4379 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1952; /* *risbgn_and_subregdi_rotr */
              if (pnum_clobbers != NULL
                  && 
#line 4379 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                {
                  *pnum_clobbers = 1;
                  return 1953; /* *risbg_and_subregdi_rotr */
                }
              if (
#line 4392 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return 1958; /* *risbgn_and_subregdi_rotl */
              if (pnum_clobbers == NULL
                  || !
#line 4392 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              *pnum_clobbers = 1;
              return 1959; /* *risbg_and_subregdi_rotl */

            case E_QImode:
              if (!register_operand (operands[1], E_QImode)
                  || !const_int_operand (operands[2], E_QImode))
                return -1;
              if (
#line 4379 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1954; /* *risbgn_and_subregdi_rotr */
              if (pnum_clobbers != NULL
                  && 
#line 4379 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                {
                  *pnum_clobbers = 1;
                  return 1955; /* *risbg_and_subregdi_rotr */
                }
              if (
#line 4392 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return 1960; /* *risbgn_and_subregdi_rotl */
              if (pnum_clobbers == NULL
                  || !
#line 4392 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              *pnum_clobbers = 1;
              return 1961; /* *risbg_and_subregdi_rotl */

            default:
              return -1;
            }

        case SUBREG:
        case MEM:
          operands[1] = x4;
          if (!memory_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x2, 1);
          if (GET_CODE (x7) != CONST_INT
              || XWINT (x7, 0) != 2147483647L)
            return -1;
          if (
#line 5167 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 2038; /* *llgt_sidi */
          if (pnum_clobbers == NULL
              || !
#line 5177 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2039; /* *llgt_sidi_split */

        default:
          return -1;
        }

    case 4:
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x7 = XEXP (x2, 1);
      operands[3] = x7;
      if (!contiguous_bitmask_nowrap_operand (operands[3], E_SImode))
        return -1;
      switch (GET_CODE (x4))
        {
        case LSHIFTRT:
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (!nonzero_shift_count_operand (operands[2], E_DImode))
            return -1;
          if (
#line 4602 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12))
            return 1988; /* *trunc_sidi_and_subreg_lshrt_nocc */
          if (pnum_clobbers == NULL
              || !
#line 4602 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
            return -1;
          *pnum_clobbers = 1;
          return 1989; /* *trunc_sidi_and_subreg_lshrt_clobbercc */

        case ZERO_EXTRACT:
          x6 = XEXP (x4, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x8 = XEXP (x4, 2);
          operands[2] = x8;
          if (!nonzero_shift_count_operand (operands[2], E_SImode))
            return -1;
          if (
#line 4616 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12))
            return 1990; /* *trunc_sidi_and_subreg_ze_nocc */
          if (pnum_clobbers == NULL
              || !
#line 4616 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
            return -1;
          *pnum_clobbers = 1;
          return 1991; /* *trunc_sidi_and_subreg_ze_clobbercc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_60 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (!register_operand (operands[0], E_V1QImode)
              || GET_MODE (x3) != E_V1QImode
              || !register_operand (operands[1], E_V1QImode)
              || !
#line 1338 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 764; /* *absv1qi2 */

        case E_V2QImode:
          if (!register_operand (operands[0], E_V2QImode)
              || GET_MODE (x3) != E_V2QImode
              || !register_operand (operands[1], E_V2QImode)
              || !
#line 1338 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 765; /* *absv2qi2 */

        case E_V4QImode:
          if (!register_operand (operands[0], E_V4QImode)
              || GET_MODE (x3) != E_V4QImode
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 1338 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 766; /* *absv4qi2 */

        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !register_operand (operands[1], E_V8QImode)
              || !
#line 1338 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 767; /* *absv8qi2 */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 1338 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 768; /* *absv16qi2 */

        case E_V1HImode:
          if (!register_operand (operands[0], E_V1HImode)
              || GET_MODE (x3) != E_V1HImode
              || !register_operand (operands[1], E_V1HImode)
              || !
#line 1338 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 769; /* *absv1hi2 */

        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[1], E_V2HImode)
              || !
#line 1338 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 770; /* *absv2hi2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 1338 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 771; /* *absv4hi2 */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 1338 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 772; /* *absv8hi2 */

        case E_V1SImode:
          if (!register_operand (operands[0], E_V1SImode)
              || GET_MODE (x3) != E_V1SImode
              || !register_operand (operands[1], E_V1SImode)
              || !
#line 1338 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 773; /* *absv1si2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 1338 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 774; /* *absv2si2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 1338 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 775; /* *absv4si2 */

        case E_V1DImode:
          if (!register_operand (operands[0], E_V1DImode)
              || GET_MODE (x3) != E_V1DImode
              || !register_operand (operands[1], E_V1DImode)
              || !
#line 1338 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 776; /* *absv1di2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 1338 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 777; /* *absv2di2 */

        case E_V1TImode:
          if (!register_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !register_operand (operands[1], E_V1TImode)
              || !(
#line 1338 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 778; /* *absv1ti2 */

        case E_TImode:
          if (!register_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !register_operand (operands[1], E_TImode)
              || !(
#line 1338 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 779; /* *absti2 */

        case E_V1SFmode:
          if (!register_operand (operands[0], E_V1SFmode)
              || GET_MODE (x3) != E_V1SFmode
              || !register_operand (operands[1], E_V1SFmode)
              || !(
#line 2107 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1282; /* absv1sf2 */

        case E_V2SFmode:
          if (!register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !register_operand (operands[1], E_V2SFmode)
              || !(
#line 2107 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1283; /* absv2sf2 */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !(
#line 2107 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1284; /* absv4sf2 */

        case E_V1DFmode:
          if (!register_operand (operands[0], E_V1DFmode)
              || GET_MODE (x3) != E_V1DFmode
              || !register_operand (operands[1], E_V1DFmode)
              || !
#line 2107 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1285; /* absv1df2 */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[1], E_V2DFmode)
              || !
#line 2107 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1286; /* absv2df2 */

        case E_V1TFmode:
          if (!register_operand (operands[0], E_V1TFmode)
              || GET_MODE (x3) != E_V1TFmode
              || !register_operand (operands[1], E_V1TFmode)
              || !(
#line 2107 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1287; /* absv1tf2 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode
              || !register_operand (operands[1], E_TFmode))
            return -1;
          if ((
#line 2107 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1288; /* abstf2_vr */
          if ((
#line 9381 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return 2477; /* *abstf2_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 9392 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2483; /* *abstf2 */

        case E_DImode:
          if (pattern83 (x3, pnum_clobbers, 
E_DImode) != 0
              || !
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2467; /* absdi2 */

        case E_SImode:
          if (pattern83 (x3, pnum_clobbers, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 2468; /* abssi2 */

        case E_FPRX2mode:
          if (!register_operand (operands[0], E_FPRX2mode)
              || GET_MODE (x3) != E_FPRX2mode
              || !register_operand (operands[1], E_FPRX2mode))
            return -1;
          if ((
#line 9381 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return 2478; /* *absfprx22_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 9392 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2484; /* *absfprx22 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !register_operand (operands[1], E_DFmode))
            return -1;
          if (
#line 9381 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
            return 2479; /* *absdf2_nocc */
          if (pnum_clobbers == NULL
              || !
#line 9392 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2485; /* *absdf2 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode))
            return -1;
          if (
#line 9381 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
            return 2480; /* *abssf2_nocc */
          if (pnum_clobbers == NULL
              || !
#line 9392 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2486; /* *abssf2 */

        case E_TDmode:
          if (!register_operand (operands[0], E_TDmode)
              || GET_MODE (x3) != E_TDmode
              || !register_operand (operands[1], E_TDmode)
              || !(
#line 9381 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2481; /* *abstd2_nocc */

        case E_DDmode:
          if (!register_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !register_operand (operands[1], E_DDmode)
              || !(
#line 9381 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2482; /* *absdd2_nocc */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pnum_clobbers == NULL
          || pattern66 (x3, 
E_SImode) != 0
          || !
#line 9304 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2462; /* *absdi2_sign */

    default:
      return -1;
    }
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XVECEXP (x5, 0, 0);
      operands[2] = x7;
      if (!const_mask_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern170 (x3, 
E_V1QImode, 
E_QImode) != 0
              || !
#line 733 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V1QImode)))
            return -1;
          return 620; /* *vec_splatv1qi */

        case E_V2QImode:
          if (pattern170 (x3, 
E_V2QImode, 
E_QImode) != 0
              || !
#line 733 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2QImode)))
            return -1;
          return 621; /* *vec_splatv2qi */

        case E_V4QImode:
          if (pattern170 (x3, 
E_V4QImode, 
E_QImode) != 0
              || !
#line 733 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4QImode)))
            return -1;
          return 622; /* *vec_splatv4qi */

        case E_V8QImode:
          if (pattern170 (x3, 
E_V8QImode, 
E_QImode) != 0
              || !
#line 733 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8QImode)))
            return -1;
          return 623; /* *vec_splatv8qi */

        case E_V16QImode:
          if (pattern170 (x3, 
E_V16QImode, 
E_QImode) != 0
              || !
#line 733 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V16QImode)))
            return -1;
          return 624; /* *vec_splatv16qi */

        case E_V1HImode:
          if (pattern170 (x3, 
E_V1HImode, 
E_HImode) != 0
              || !
#line 733 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V1HImode)))
            return -1;
          return 625; /* *vec_splatv1hi */

        case E_V2HImode:
          if (pattern170 (x3, 
E_V2HImode, 
E_HImode) != 0
              || !
#line 733 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2HImode)))
            return -1;
          return 626; /* *vec_splatv2hi */

        case E_V4HImode:
          if (pattern170 (x3, 
E_V4HImode, 
E_HImode) != 0
              || !
#line 733 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4HImode)))
            return -1;
          return 627; /* *vec_splatv4hi */

        case E_V8HImode:
          if (pattern170 (x3, 
E_V8HImode, 
E_HImode) != 0
              || !
#line 733 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
            return -1;
          return 628; /* *vec_splatv8hi */

        case E_V1SImode:
          if (pattern170 (x3, 
E_V1SImode, 
E_SImode) != 0
              || !
#line 733 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V1SImode)))
            return -1;
          return 629; /* *vec_splatv1si */

        case E_V2SImode:
          if (pattern170 (x3, 
E_V2SImode, 
E_SImode) != 0
              || !
#line 733 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2SImode)))
            return -1;
          return 630; /* *vec_splatv2si */

        case E_V4SImode:
          if (pattern170 (x3, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 733 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 631; /* *vec_splatv4si */

        case E_V1DImode:
          if (pattern170 (x3, 
E_V1DImode, 
E_DImode) != 0
              || !
#line 733 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V1DImode)))
            return -1;
          return 632; /* *vec_splatv1di */

        case E_V2DImode:
          if (pattern170 (x3, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 733 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 633; /* *vec_splatv2di */

        case E_V1SFmode:
          if (pattern170 (x3, 
E_V1SFmode, 
E_SFmode) != 0
              || !
#line 733 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V1SFmode)))
            return -1;
          return 634; /* *vec_splatv1sf */

        case E_V2SFmode:
          if (pattern170 (x3, 
E_V2SFmode, 
E_SFmode) != 0
              || !
#line 733 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2SFmode)))
            return -1;
          return 635; /* *vec_splatv2sf */

        case E_V4SFmode:
          if (pattern170 (x3, 
E_V4SFmode, 
E_SFmode) != 0
              || !
#line 733 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)))
            return -1;
          return 636; /* *vec_splatv4sf */

        case E_V1DFmode:
          if (pattern170 (x3, 
E_V1DFmode, 
E_DFmode) != 0
              || !
#line 733 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V1DFmode)))
            return -1;
          return 637; /* *vec_splatv1df */

        case E_V2DFmode:
          if (pattern170 (x3, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 733 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 638; /* *vec_splatv2df */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !general_operand (operands[1], E_QImode)
              || !
#line 741 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 639; /* *vec_splatsv16qi */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !general_operand (operands[1], E_HImode)
              || !
#line 741 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 640; /* *vec_splatsv8hi */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !general_operand (operands[1], E_SImode)
              || !
#line 741 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 641; /* *vec_splatsv4si */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !general_operand (operands[1], E_SFmode)
              || !
#line 741 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 642; /* *vec_splatsv4sf */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !general_operand (operands[1], E_DImode)
              || !
#line 741 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 643; /* *vec_splatsv2di */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !general_operand (operands[1], E_DFmode)
              || !
#line 741 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 644; /* *vec_splatsv2df */

        case E_V1TFmode:
          if (!nonimmediate_operand (operands[0], E_V1TFmode)
              || GET_MODE (x3) != E_V1TFmode
              || !general_operand (operands[1], E_TFmode))
            return -1;
          if (
#line 774 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE))
            return 655; /* *vec_tf_to_v1tf_fpr */
          if (!
#line 787 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 656; /* *vec_tf_to_v1tf_vr */

        case E_V1TImode:
          if (!nonimmediate_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !general_operand (operands[1], E_TImode)
              || !
#line 817 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 658; /* *vec_ti_to_v1ti */

        default:
          return -1;
        }

    case BSWAP:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern84 (x3, 
E_HImode, 
E_V8HImode) != 0
              || !
#line 765 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 650; /* *vec_splats_bswap_elemv8hi */

        case E_V4SImode:
          if (pattern84 (x3, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 765 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 651; /* *vec_splats_bswap_elemv4si */

        case E_V4SFmode:
          if (pattern84 (x3, 
E_SFmode, 
E_V4SFmode) != 0
              || !(
#line 765 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 44 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 652; /* *vec_splats_bswap_elemv4sf */

        case E_V2DImode:
          if (pattern84 (x3, 
E_DImode, 
E_V2DImode) != 0
              || !
#line 765 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 653; /* *vec_splats_bswap_elemv2di */

        case E_V2DFmode:
          if (pattern84 (x3, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 765 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 654; /* *vec_splats_bswap_elemv2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_75 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 3085 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1543; /* floatv2div2df2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SImode)
          || !(
#line 3085 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 101 "../../gcc/config/s390/vector.md"
(TARGET_VXE2)))
        return -1;
      return 1544; /* floatv4siv4sf2 */

    case E_TFmode:
      switch (pattern67 (x3, 
E_TFmode))
        {
        case 0:
          if (!(
#line 5633 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2082; /* floatditf2_fpr */

        case 1:
          if (!(
#line 5646 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2088; /* floatsitf2_fpr */

        default:
          return -1;
        }

    case E_FPRX2mode:
      switch (pattern67 (x3, 
E_FPRX2mode))
        {
        case 0:
          if (!(
#line 5633 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2083; /* floatdifprx22 */

        case 1:
          if (!(
#line 5646 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2089; /* floatsifprx22 */

        default:
          return -1;
        }

    case E_DFmode:
      switch (pattern67 (x3, 
E_DFmode))
        {
        case 0:
          if (!
#line 5633 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT))
            return -1;
          return 2084; /* floatdidf2 */

        case 1:
          if (!
#line 5646 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2090; /* floatsidf2 */

        default:
          return -1;
        }

    case E_SFmode:
      switch (pattern67 (x3, 
E_SFmode))
        {
        case 0:
          if (!
#line 5633 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT))
            return -1;
          return 2085; /* floatdisf2 */

        case 1:
          if (!
#line 5646 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2091; /* floatsisf2 */

        default:
          return -1;
        }

    case E_TDmode:
      switch (pattern67 (x3, 
E_TDmode))
        {
        case 0:
          if (!(
#line 5633 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2086; /* floatditd2 */

        case 1:
          if (!
#line 5659 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT))
            return -1;
          return 2092; /* floatsitd2 */

        default:
          return -1;
        }

    case E_DDmode:
      switch (pattern67 (x3, 
E_DDmode))
        {
        case 0:
          if (!(
#line 5633 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2087; /* floatdidd2 */

        case 1:
          if (!
#line 5659 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT))
            return -1;
          return 2093; /* floatsidd2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_85 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != ABS
          || !register_operand (operands[1], E_DImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      switch (GET_MODE (x8))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !(
#line 9316 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2463; /* *absdi2_cc */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !
#line 9316 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2464; /* *abssi2_cc */

        default:
          return -1;
        }

    case CLOBBER:
      switch (pattern191 (x1))
        {
        case 0:
          if (!(
#line 9327 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2465; /* *absdi2_cconly */

        case 1:
          if (!
#line 9327 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2466; /* *abssi2_cconly */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_93 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTRACT:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (pattern89 (x4) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      operands[0] = x5;
      if (!nonimmediate_operand (operands[0], E_DImode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x7 = XEXP (x3, 2);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x8 = XEXP (x2, 1);
      if (GET_MODE (x8) != E_DImode)
        return -1;
      x9 = XEXP (x8, 1);
      operands[3] = x9;
      if (!nonimmediate_operand (operands[3], E_DImode))
        return -1;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[0])
          || !
#line 4833 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && INTVAL (operands[1]) + INTVAL (operands[2]) == 64))
        return -1;
      return 2016; /* *insv_rnsbg_noshift */

    case SUBREG:
    case MEM:
      if (pnum_clobbers == NULL)
        return -1;
      operands[0] = x3;
      if (!memory_operand (operands[0], E_BLKmode))
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x8 = XEXP (x2, 1);
      if (GET_MODE (x8) != E_BLKmode)
        return -1;
      x9 = XEXP (x8, 1);
      operands[1] = x9;
      if (!memory_operand (operands[1], E_BLKmode))
        return -1;
      x11 = XEXP (x4, 0);
      operands[2] = x11;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[0])
          || !
#line 8265 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      *pnum_clobbers = 1;
      return 2379; /* *nc */

    default:
      return -1;
    }
}

 int
recog_98 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pattern38 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (pattern213 (x3, 
E_TImode) != 0
              || !
#line 6072 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2208; /* *addti3 */

        case E_DImode:
          if (pattern121 (x3, 
E_DImode) != 0)
            return -1;
          if (
#line 6163 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return 2213; /* *adddi3_31z */
          if (!
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2215; /* *adddi3 */

        case E_SImode:
          if (pattern121 (x3, 
E_SImode) != 0)
            return -1;
          return 2216; /* *addsi3 */

        case E_TFmode:
          if (pattern213 (x3, 
E_TFmode) != 0
              || !(
#line 6490 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2238; /* addtf3_fpr */

        case E_FPRX2mode:
          if (pattern213 (x3, 
E_FPRX2mode) != 0
              || !(
#line 6490 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2239; /* addfprx23 */

        case E_DFmode:
          if (pattern213 (x3, 
E_DFmode) != 0
              || !
#line 6490 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2240; /* adddf3 */

        case E_SFmode:
          if (pattern213 (x3, 
E_SFmode) != 0
              || !
#line 6490 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2241; /* addsf3 */

        case E_TDmode:
          if (pattern213 (x3, 
E_TDmode) != 0
              || !(
#line 6490 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2242; /* addtd3 */

        case E_DDmode:
          if (pattern213 (x3, 
E_DDmode) != 0
              || !(
#line 6490 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2243; /* adddd3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          if (general_operand (operands[2], E_SImode)
              && 
#line 6112 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 2209; /* *adddi3_sign */
          if (!memory_operand (operands[2], E_HImode)
              || !
#line 6398 "../../gcc/config/s390/s390.md"
(TARGET_Z14))
            return -1;
          return 2233; /* *adddi3_sign */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode
              || !memory_operand (operands[2], E_HImode)
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 2214; /* *addsi3_sign */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!general_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 6151 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 2212; /* *adddi3_zero */

    case PLUS:
      x6 = XEXP (x4, 0);
      operands[3] = x6;
      x7 = XEXP (x4, 1);
      operands[1] = x7;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern246 (x3, 
E_DImode) != 0
              || !
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2308; /* *adddi3_alc */

        case E_SImode:
          if (pattern246 (x3, 
E_SImode) != 0)
            return -1;
          return 2309; /* *addsi3_alc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  if (!permute_pattern_operand (x5, E_V16QImode))
    return -1;
  x6 = XEXP (x3, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case UNSPEC:
      switch (XVECLEN (x7, 0))
        {
        case 1:
          if (XINT (x7, 1) != 62)
            return -1;
          x8 = XVECEXP (x7, 0, 0);
          operands[1] = x8;
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern222 (x6, 
E_HImode, 
E_V8HImode) != 0
                  || !
#line 191 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 11; /* *vec_insert_and_zero_bswapv8hi */

            case E_V4SImode:
              if (pattern222 (x6, 
E_SImode, 
E_V4SImode) != 0
                  || !
#line 191 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 12; /* *vec_insert_and_zero_bswapv4si */

            case E_V4SFmode:
              if (pattern222 (x6, 
E_SFmode, 
E_V4SFmode) != 0
                  || !(
#line 191 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 44 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 13; /* *vec_insert_and_zero_bswapv4sf */

            case E_V2DImode:
              if (pattern222 (x6, 
E_DImode, 
E_V2DImode) != 0
                  || !
#line 191 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 14; /* *vec_insert_and_zero_bswapv2di */

            case E_V2DFmode:
              if (pattern222 (x6, 
E_DFmode, 
E_V2DFmode) != 0
                  || !
#line 191 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 15; /* *vec_insert_and_zero_bswapv2df */

            default:
              return -1;
            }

        case 3:
          if (XINT (x7, 1) != 92)
            return -1;
          x9 = XVECEXP (x7, 0, 2);
          if (GET_CODE (x9) != BSWAP)
            return -1;
          x8 = XVECEXP (x7, 0, 0);
          operands[1] = x8;
          x10 = XVECEXP (x7, 0, 1);
          operands[2] = x10;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x11 = XEXP (x9, 0);
          operands[3] = x11;
          operands[4] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern259 (x6, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 2183 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
                return -1;
              return 486; /* *vec_set_bswap_vecv8hi */

            case E_V4SImode:
              if (pattern259 (x6, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 2183 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
                return -1;
              return 487; /* *vec_set_bswap_vecv4si */

            case E_V4SFmode:
              if (pattern259 (x6, 
E_V4SFmode, 
E_SFmode) != 0
                  || !(
#line 2183 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 44 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 488; /* *vec_set_bswap_vecv4sf */

            case E_V2DImode:
              if (pattern259 (x6, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 2183 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
                return -1;
              return 489; /* *vec_set_bswap_vecv2di */

            case E_V2DFmode:
              if (pattern259 (x6, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 2183 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
                return -1;
              return 490; /* *vec_set_bswap_vecv2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x12 = XEXP (x7, 0);
      operands[1] = x12;
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern189 (x6, 
E_HImode, 
E_V8HImode) != 0
              || !
#line 755 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 645; /* *vec_splats_bswap_vecv8hi */

        case E_V4SImode:
          if (pattern189 (x6, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 755 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 646; /* *vec_splats_bswap_vecv4si */

        case E_V4SFmode:
          if (pattern189 (x6, 
E_SFmode, 
E_V4SFmode) != 0
              || !(
#line 755 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 44 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 647; /* *vec_splats_bswap_vecv4sf */

        case E_V2DImode:
          if (pattern189 (x6, 
E_DImode, 
E_V2DImode) != 0
              || !
#line 755 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 648; /* *vec_splats_bswap_vecv2di */

        case E_V2DFmode:
          if (pattern189 (x6, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 755 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 649; /* *vec_splats_bswap_vecv2df */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x7;
      operands[2] = x5;
      switch (pattern163 (x6))
        {
        case 0:
          if (!
#line 3473 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1577; /* *bswapv8hi */

        case 1:
          if (!
#line 3473 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1578; /* *bswapv4si */

        case 2:
          if (!
#line 3473 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1579; /* *bswapv4sf */

        case 3:
          if (!
#line 3473 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1580; /* *bswapv2di */

        case 4:
          if (!
#line 3473 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1581; /* *bswapv2df */

        case 5:
          if (!
#line 3473 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1582; /* *bswapv1ti */

        case 6:
          if (!
#line 3473 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1583; /* *bswapv1tf */

        case 7:
          if (!
#line 3473 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1584; /* *bswapti */

        case 8:
          if (!
#line 3473 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1585; /* *bswaptf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_112 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case VEC_SELECT:
      if (GET_MODE (x3) != E_V8HImode)
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != PARALLEL
          || XVECLEN (x4, 0) != 8)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x7 = XVECEXP (x4, 0, 2);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x8 = XVECEXP (x4, 0, 3);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x9 = XVECEXP (x4, 0, 4);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x10 = XVECEXP (x4, 0, 5);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x11 = XVECEXP (x4, 0, 6);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x12 = XVECEXP (x4, 0, 7);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != CLOBBER)
        return -1;
      x14 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x14) != CLOBBER
          || pattern265 (x1) != 0
          || !
#line 1159 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 691; /* eltswapv8hi */

    case UNSPEC:
      if (XVECLEN (x3, 0) != 4
          || XINT (x3, 1) != 31)
        return -1;
      x15 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x15) != MEM
          || GET_MODE (x15) != E_BLKmode)
        return -1;
      x16 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x16) != REG
          || REGNO (x16) != 0
          || GET_MODE (x16) != E_SImode)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != CLOBBER)
        return -1;
      x14 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x14) != CLOBBER)
        return -1;
      x17 = XEXP (x14, 0);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 33
          || GET_MODE (x17) != E_CCmode)
        return -1;
      x18 = XEXP (x2, 0);
      operands[0] = x18;
      x19 = XVECEXP (x3, 0, 0);
      operands[2] = x19;
      x20 = XEXP (x15, 0);
      operands[3] = x20;
      x21 = XVECEXP (x3, 0, 3);
      operands[4] = x21;
      if (!immediate_operand (operands[4], E_VOIDmode))
        return -1;
      x22 = XEXP (x13, 0);
      operands[1] = x22;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern290 (x3, 
E_DImode) != 0
              || !
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
            return -1;
          return 1898; /* *strlendi */

        case E_SImode:
          if (pattern290 (x3, 
E_SImode) != 0
              || !
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
            return -1;
          return 1899; /* *strlensi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      x18 = XEXP (x2, 0);
      switch (GET_CODE (x18))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x18;
          operands[1] = x3;
          x13 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x13))
            {
            case USE:
              if (pnum_clobbers == NULL)
                return -1;
              x14 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x14) != USE
                  || !memory_operand (operands[0], E_BLKmode)
                  || !memory_operand (operands[1], E_BLKmode))
                return -1;
              x22 = XEXP (x13, 0);
              operands[2] = x22;
              if (!nonmemory_operand (operands[2], E_VOIDmode))
                return -1;
              x17 = XEXP (x14, 0);
              operands[3] = x17;
              if (!immediate_operand (operands[3], E_VOIDmode))
                return -1;
              if ((
#line 3594 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1904; /* *cpymem_short */
                }
              if (!(
#line 3594 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1905; /* *cpymem_short */

            case SET:
              x23 = XEXP (x13, 1);
              if (pattern152 (x23, 
E_TImode, 
9, 
UNSPEC_VOLATILE, 
3) != 0)
                return -1;
              x14 = XVECEXP (x1, 0, 2);
              if (pattern181 (x14) != 0
                  || !register_operand (operands[0], E_TImode)
                  || !nonsym_memory_operand (operands[1], E_TImode))
                return -1;
              x24 = XVECEXP (x23, 0, 1);
              operands[2] = x24;
              if (!register_operand (operands[2], E_TImode))
                return -1;
              x25 = XVECEXP (x23, 0, 2);
              operands[3] = x25;
              if (!register_operand (operands[3], E_TImode))
                return -1;
              x26 = XVECEXP (x23, 0, 0);
              if (!rtx_equal_p (x26, operands[1]))
                return -1;
              x22 = XEXP (x13, 0);
              if (!rtx_equal_p (x22, operands[1]))
                return -1;
              x27 = XEXP (x14, 1);
              x28 = XEXP (x27, 0);
              if (!rtx_equal_p (x28, operands[1]))
                return -1;
              x29 = XEXP (x27, 1);
              if (!rtx_equal_p (x29, operands[2])
                  || !
#line 11352 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && s390_match_ccmode (insn, CCZ1mode)))
                return -1;
              return 2609; /* *atomic_compare_and_swapti_1 */

            default:
              return -1;
            }

        case PC:
          x13 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x13) != USE)
            return -1;
          x22 = XEXP (x13, 0);
          if (GET_CODE (x22) != LABEL_REF)
            return -1;
          x14 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x14) != CLOBBER)
            return -1;
          x17 = XEXP (x14, 0);
          if (GET_CODE (x17) != REG
              || REGNO (x17) != 1)
            return -1;
          operands[0] = x3;
          x30 = XEXP (x22, 0);
          operands[1] = x30;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x17) != E_DImode
                  || !(
#line 10591 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 2572; /* casesi_jump_via_thunkdi */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x17) != E_SImode
                  || !(
#line 10591 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 2573; /* casesi_jump_via_thunksi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x3, 0) != 0L)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != USE)
        return -1;
      x18 = XEXP (x2, 0);
      operands[0] = x18;
      if (!memory_operand (operands[0], E_BLKmode))
        return -1;
      x22 = XEXP (x13, 0);
      operands[1] = x22;
      x14 = XVECEXP (x1, 0, 2);
      switch (GET_CODE (x14))
        {
        case USE:
          if (pnum_clobbers == NULL
              || !nonmemory_operand (operands[1], E_VOIDmode))
            return -1;
          x17 = XEXP (x14, 0);
          operands[2] = x17;
          if (!immediate_operand (operands[2], E_VOIDmode))
            return -1;
          if ((
#line 3849 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[1]) == Pmode || GET_MODE (operands[1]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 2;
              return 1918; /* *clrmem_short */
            }
          if (!(
#line 3849 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[1]) == Pmode || GET_MODE (operands[1]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 2;
          return 1919; /* *clrmem_short */

        case CLOBBER:
          x17 = XEXP (x14, 0);
          if (GET_CODE (x17) != REG
              || REGNO (x17) != 33
              || GET_MODE (x17) != E_CCmode
              || !const_int_operand (operands[1], E_VOIDmode)
              || !
#line 9005 "../../gcc/config/s390/s390.md"
(INTVAL (operands[1]) >= 1 && INTVAL (operands[1]) <= 256))
            return -1;
          return 2427; /* *xc_zero */

        default:
          return -1;
        }

    case COMPARE:
      if (pnum_clobbers == NULL
          || pattern73 (x1) != 0)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      x22 = XEXP (x13, 0);
      operands[2] = x22;
      if (!nonmemory_operand (operands[2], E_VOIDmode))
        return -1;
      x14 = XVECEXP (x1, 0, 2);
      x17 = XEXP (x14, 0);
      operands[3] = x17;
      if (!immediate_operand (operands[3], E_VOIDmode))
        return -1;
      if ((
#line 4043 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 1926; /* *cmpmem_short */
        }
      if (!(
#line 4043 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1927; /* *cmpmem_short */

    case UNSIGNED_FIX:
      if (pattern42 (x1) != 0)
        return -1;
      switch (pattern150 (x1))
        {
        case 0:
          if (
#line 5521 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
            return 2056; /* *fixuns_truncdfdi2_z13 */
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DFmode != DFmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2062; /* *fixuns_truncdfdi2_z196 */

        case 1:
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TFmode != DFmode)) && (((
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2058; /* *fixuns_trunctfdi2_z196 */

        case 2:
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || FPRX2mode != DFmode)) && (((
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2060; /* *fixuns_truncfprx2di2_z196 */

        case 3:
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || SFmode != DFmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2064; /* *fixuns_truncsfdi2_z196 */

        case 4:
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TDmode != DFmode)) && (((
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2066; /* *fixuns_trunctddi2_z196 */

        case 5:
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DDmode != DFmode)) && (((
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2068; /* *fixuns_truncdddi2_z196 */

        case 6:
          if (!(
#line 5521 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT) && 
#line 767 "../../gcc/config/s390/s390.md"
(TARGET_VXE2)))
            return -1;
          return 2057; /* *fixuns_truncsfsi2_z13 */

        case 7:
          if (!
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || SFmode != DFmode)))
            return -1;
          return 2065; /* *fixuns_truncsfsi2_z196 */

        case 8:
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TFmode != DFmode)) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2059; /* *fixuns_trunctfsi2_z196 */

        case 9:
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || FPRX2mode != DFmode)) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2061; /* *fixuns_truncfprx2si2_z196 */

        case 10:
          if (!
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DFmode != DFmode)))
            return -1;
          return 2063; /* *fixuns_truncdfsi2_z196 */

        case 11:
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TDmode != DFmode)) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2067; /* *fixuns_trunctdsi2_z196 */

        case 12:
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DDmode != DFmode)) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2069; /* *fixuns_truncddsi2_z196 */

        default:
          return -1;
        }

    case FIX:
      if (pattern42 (x1) != 0)
        return -1;
      switch (pattern151 (x1))
        {
        case 0:
          if (
#line 5559 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
            return 2070; /* *fix_truncdfdi2_bfp_z13 */
          if (!(
#line 5572 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DFmode != DFmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2076; /* *fix_truncdfdi2_bfp */

        case 1:
          if (!(
#line 5572 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TFmode != DFmode)) && (((
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2072; /* *fix_trunctfdi2_bfp */

        case 2:
          if (!(
#line 5572 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || FPRX2mode != DFmode)) && (((
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2074; /* *fix_truncfprx2di2_bfp */

        case 3:
          if (!(
#line 5572 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || SFmode != DFmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2078; /* *fix_truncsfdi2_bfp */

        case 4:
          if (!
#line 5606 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_DFP))
            return -1;
          return 2080; /* fix_trunctddi2_dfp */

        case 5:
          if (!
#line 5606 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_DFP))
            return -1;
          return 2081; /* fix_truncdddi2_dfp */

        case 6:
          if ((
#line 5559 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT) && 
#line 767 "../../gcc/config/s390/s390.md"
(TARGET_VXE2)))
            return 2071; /* *fix_truncsfsi2_bfp_z13 */
          if (!
#line 5572 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || SFmode != DFmode)))
            return -1;
          return 2079; /* *fix_truncsfsi2_bfp */

        case 7:
          if (!(
#line 5572 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TFmode != DFmode)) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2073; /* *fix_trunctfsi2_bfp */

        case 8:
          if (!(
#line 5572 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || FPRX2mode != DFmode)) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2075; /* *fix_truncfprx2si2_bfp */

        case 9:
          if (!
#line 5572 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DFmode != DFmode)))
            return -1;
          return 2077; /* *fix_truncdfsi2_bfp */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      if (GET_MODE (x3) != E_DDmode)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != UNSPEC
          || XVECLEN (x13, 0) != 1
          || XINT (x13, 1) != 0
          || GET_MODE (x13) != E_DImode)
        return -1;
      x14 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x14) != CLOBBER)
        return -1;
      x18 = XEXP (x2, 0);
      operands[0] = x18;
      if (!register_operand (operands[0], E_DDmode))
        return -1;
      x31 = XEXP (x3, 0);
      operands[1] = x31;
      if (!register_operand (operands[1], E_TDmode))
        return -1;
      x32 = XVECEXP (x13, 0, 0);
      operands[2] = x32;
      if (!const_mask_operand (operands[2], E_DImode))
        return -1;
      x17 = XEXP (x14, 0);
      operands[3] = x17;
      if (!scratch_operand (operands[3], E_TDmode)
          || !
#line 5742 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
        return -1;
      return 2111; /* *trunctddd2 */

    case AND:
      if (pattern43 (x1) != 0
          || !
#line 8265 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      return 2379; /* *nc */

    case IOR:
      if (pattern43 (x1) != 0
          || !
#line 8675 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      return 2417; /* *oc */

    case XOR:
      if (pattern43 (x1) != 0
          || !
#line 8948 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      return 2426; /* *xc */

    case IF_THEN_ELSE:
      x31 = XEXP (x3, 0);
      if (!s390_brx_operator (x31, E_VOIDmode))
        return -1;
      operands[6] = x31;
      x33 = XEXP (x31, 0);
      if (GET_CODE (x33) != PLUS)
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != LABEL_REF)
        return -1;
      x34 = XEXP (x3, 2);
      if (GET_CODE (x34) != PC)
        return -1;
      x18 = XEXP (x2, 0);
      if (GET_CODE (x18) != PC)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != SET)
        return -1;
      x23 = XEXP (x13, 1);
      if (GET_CODE (x23) != PLUS)
        return -1;
      x14 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x14) != CLOBBER)
        return -1;
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2551; /* *brx_stage1_di */

        case 1:
          return 2552; /* *brx_stage1_si */

        default:
          return -1;
        }

    case CALL:
      x31 = XEXP (x3, 0);
      if (GET_CODE (x31) != MEM
          || GET_MODE (x31) != E_QImode)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != CLOBBER)
        return -1;
      x18 = XEXP (x2, 0);
      operands[0] = x18;
      x33 = XEXP (x31, 0);
      operands[1] = x33;
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x22 = XEXP (x13, 0);
      operands[3] = x22;
      if (!register_operand (operands[3], E_VOIDmode))
        return -1;
      switch (GET_CODE (operands[1]))
        {
        case REG:
        case SUBREG:
          res = recog_111 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case CONST:
        case SYMBOL_REF:
          if (bras_sym_operand (operands[1], E_VOIDmode))
            {
              x14 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x14) == USE)
                {
                  x17 = XEXP (x14, 0);
                  operands[4] = x17;
                  if (
#line 11119 "../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)
   && TARGET_SMALL_EXEC
   && GET_MODE (operands[3]) == Pmode))
                    return 2601; /* *bras_tls */
                  if (
#line 11133 "../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)

   && GET_MODE (operands[3]) == Pmode))
                    return 2602; /* *brasl_tls */
                }
            }
          break;

        default:
          break;
        }
      x14 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x14) != USE
          || !address_operand (operands[1], E_VOIDmode))
        return -1;
      x17 = XEXP (x14, 0);
      operands[4] = x17;
      if (!
#line 11148 "../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn) && GET_MODE (operands[3]) == Pmode))
        return -1;
      return 2603; /* *basr_tls */

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          if (peep2_current_count >= 2)
            {
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (register_operand (operands[0], E_DImode))
                    {
                      operands[2] = x3;
                      x4 = PATTERN (peep2_next_insn (1));
                      if (pattern127 (x4, 
E_DImode) == 0
                          && (
#line 1112 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (peep2_next_insn (1), CCSmode) && TARGET_EXTIMM
   && GENERAL_REG_P (operands[0])
   && satisfies_constraint_T (operands[2])
   && !contains_constant_pool_address_p (operands[2])) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_1 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      operands[1] = x3;
                      if (pattern128 (x4, 
E_DImode) == 0
                          && 
#line 2338 "../../gcc/config/s390/s390.md"
(TARGET_64BIT
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && preferred_la_operand_p (operands[1], operands[2])))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_11 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  break;

                case E_SImode:
                  if (register_operand (operands[0], E_SImode))
                    {
                      operands[2] = x3;
                      x4 = PATTERN (peep2_next_insn (1));
                      if (pattern127 (x4, 
E_SImode) == 0
                          && 
#line 1112 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (peep2_next_insn (1), CCSmode) && TARGET_EXTIMM
   && GENERAL_REG_P (operands[0])
   && satisfies_constraint_T (operands[2])
   && !contains_constant_pool_address_p (operands[2])))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_2 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      operands[1] = x3;
                      if (pattern128 (x4, 
E_SImode) == 0
                          && 
#line 2565 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && preferred_la_operand_p (operands[1], operands[2])))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_15 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  break;

                default:
                  break;
                }
            }
          if (GET_CODE (x3) == MEM)
            {
              x5 = XEXP (x3, 0);
              operands[1] = x5;
              if (address_operand (operands[1], E_VOIDmode))
                {
                  switch (GET_MODE (operands[0]))
                    {
                    case E_DImode:
                      if (register_operand (operands[0], E_DImode)
                          && GET_MODE (x3) == E_DImode
                          && 
#line 2299 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && !FP_REG_P (operands[0])
   && GET_CODE (operands[1]) == SYMBOL_REF
   && CONSTANT_POOL_ADDRESS_P (operands[1])
   && get_pool_mode (operands[1]) == DImode
   && legitimate_reload_constant_p (get_pool_constant (operands[1]))))
                        {
                          *pmatch_len_ = 0;
                          res = gen_peephole2_9 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      break;

                    case E_SImode:
                      if (register_operand (operands[0], E_SImode)
                          && GET_MODE (x3) == E_SImode
                          && 
#line 2527 "../../gcc/config/s390/s390.md"
(!FP_REG_P (operands[0])
   && GET_CODE (operands[1]) == SYMBOL_REF
   && CONSTANT_POOL_ADDRESS_P (operands[1])
   && get_pool_mode (operands[1]) == SImode
   && legitimate_reload_constant_p (get_pool_constant (operands[1]))))
                        {
                          *pmatch_len_ = 0;
                          res = gen_peephole2_13 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      break;

                    case E_HImode:
                      if (register_operand (operands[0], E_HImode)
                          && GET_MODE (x3) == E_HImode
                          && 
#line 2670 "../../gcc/config/s390/s390.md"
(GET_CODE (operands[1]) == SYMBOL_REF
   && CONSTANT_POOL_ADDRESS_P (operands[1])
   && get_pool_mode (operands[1]) == HImode
   && GET_CODE (get_pool_constant (operands[1])) == CONST_INT))
                        {
                          *pmatch_len_ = 0;
                          res = gen_peephole2_16 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      break;

                    case E_QImode:
                      if (nonimmediate_operand (operands[0], E_QImode)
                          && GET_MODE (x3) == E_QImode
                          && 
#line 2735 "../../gcc/config/s390/s390.md"
(GET_CODE (operands[1]) == SYMBOL_REF
   && CONSTANT_POOL_ADDRESS_P (operands[1])
   && get_pool_mode (operands[1]) == QImode
   && GET_CODE (get_pool_constant (operands[1])) == CONST_INT))
                        {
                          *pmatch_len_ = 0;
                          res = gen_peephole2_17 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      break;

                    default:
                      break;
                    }
                }
            }
          operands[1] = x3;
          if (!memory_operand (operands[1], E_DImode)
              || !register_operand (operands[0], E_DImode)
              || !
#line 2350 "../../gcc/config/s390/s390.md"
(TARGET_64BIT
   && TARGET_EXTIMM
   && GENERAL_REG_P (operands[0])
   && s390_const_int_pool_entry_p (operands[1], nullptr)
   && peep2_reg_dead_p (1, gen_rtx_REG (CCmode, CC_REGNUM))))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_12 (insn, operands);

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          if (peep2_current_count < 2)
            return NULL;
          operands[1] = x3;
          x4 = PATTERN (peep2_next_insn (1));
          if (GET_CODE (x4) != SET)
            return NULL;
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != COMPARE
              || GET_MODE (x6) != E_CCZmode)
            return NULL;
          x7 = XEXP (x4, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 33
              || GET_MODE (x7) != E_CCZmode)
            return NULL;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          x9 = XEXP (x6, 1);
          operands[3] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_TFmode:
              if (pattern241 (
E_TFmode) != 0
                  || !(
#line 1545 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_3 (insn, operands);

            case E_FPRX2mode:
              if (pattern241 (
E_FPRX2mode) != 0
                  || !(
#line 1545 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_4 (insn, operands);

            case E_DFmode:
              if (pattern241 (
E_DFmode) != 0
                  || !
#line 1545 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_5 (insn, operands);

            case E_SFmode:
              if (pattern241 (
E_SFmode) != 0
                  || !
#line 1545 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_6 (insn, operands);

            case E_TDmode:
              if (pattern241 (
E_TDmode) != 0
                  || !(
#line 1545 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_7 (insn, operands);

            case E_DDmode:
              if (pattern241 (
E_DDmode) != 0
                  || !(
#line 1545 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_8 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x10 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x10) != SET)
            return NULL;
          x11 = XEXP (x10, 0);
          operands[0] = x11;
          x12 = XEXP (x10, 1);
          operands[1] = x12;
          x13 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x13))
            {
            case CLOBBER:
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != REG
                  || REGNO (x14) != 33
                  || GET_MODE (x14) != E_CCmode
                  || !address_operand (operands[1], E_QImode))
                return NULL;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !
#line 2325 "../../gcc/config/s390/s390.md"
(TARGET_64BIT
   && preferred_la_operand_p (operands[1], const0_rtx)))
                    return NULL;
                  *pmatch_len_ = 0;
                  return gen_peephole2_10 (insn, operands);

                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !
#line 2552 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT
   && preferred_la_operand_p (operands[1], const0_rtx)))
                    return NULL;
                  *pmatch_len_ = 0;
                  return gen_peephole2_14 (insn, operands);

                default:
                  return NULL;
                }

            case USE:
              if (peep2_current_count >= 2)
                {
                  res = peephole2_1 (x1, insn, pmatch_len_);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!plus16_Q_operand (operands[0], E_BLKmode)
                  || !plus16_Q_operand (operands[1], E_BLKmode))
                return NULL;
              x14 = XEXP (x13, 0);
              operands[2] = x14;
              if (!const_int_operand (operands[2], E_VOIDmode)
                  || !
#line 3161 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) > 16 && INTVAL (operands[2]) <= 32))
                return NULL;
              *pmatch_len_ = 0;
              return gen_peephole2_19 (insn, operands);

            default:
              return NULL;
            }

        case 3:
          if (peep2_current_count < 2)
            return NULL;
          x10 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x10) != SET)
            return NULL;
          x13 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x13) != USE)
            return NULL;
          x15 = XVECEXP (x1, 0, 2);
          if (pattern41 (x15) != 0)
            return NULL;
          x11 = XEXP (x10, 0);
          operands[0] = x11;
          if (!memory_operand (operands[0], E_BLKmode))
            return NULL;
          x14 = XEXP (x13, 0);
          if (!const_int_operand (x14, E_VOIDmode))
            return NULL;
          x4 = PATTERN (peep2_next_insn (1));
          if (pattern196 (x4, 
3) != 0)
            return NULL;
          x16 = XVECEXP (x4, 0, 2);
          if (GET_CODE (x16) != CLOBBER)
            return NULL;
          x17 = XEXP (x16, 0);
          if (GET_CODE (x17) != REG
              || REGNO (x17) != 33
              || GET_MODE (x17) != E_CCmode)
            return NULL;
          x18 = XVECEXP (x4, 0, 0);
          x19 = XEXP (x18, 0);
          if (!memory_operand (x19, E_BLKmode))
            return NULL;
          x20 = XVECEXP (x4, 0, 1);
          x21 = XEXP (x20, 0);
          if (!const_int_operand (x21, E_VOIDmode))
            return NULL;
          x12 = XEXP (x10, 1);
          switch (GET_CODE (x12))
            {
            case AND:
              if (pattern292 (x1, 
AND) != 0
                  || !
#line 8301 "../../gcc/config/s390/s390.md"
(s390_offset_p (operands[0], operands[3], operands[2])
   && s390_offset_p (operands[1], operands[4], operands[2])
   && !s390_overlap_p (operands[0], operands[1],
                       INTVAL (operands[2]) + INTVAL (operands[5]))
   && INTVAL (operands[2]) + INTVAL (operands[5]) <= 256))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_20 (insn, operands);

            case IOR:
              if (pattern292 (x1, 
IOR) != 0
                  || !
#line 8711 "../../gcc/config/s390/s390.md"
(s390_offset_p (operands[0], operands[3], operands[2])
   && s390_offset_p (operands[1], operands[4], operands[2])
   && !s390_overlap_p (operands[0], operands[1],
                       INTVAL (operands[2]) + INTVAL (operands[5]))
   && INTVAL (operands[2]) + INTVAL (operands[5]) <= 256))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_21 (insn, operands);

            case XOR:
              if (pattern292 (x1, 
XOR) != 0
                  || !
#line 8983 "../../gcc/config/s390/s390.md"
(s390_offset_p (operands[0], operands[3], operands[2])
   && s390_offset_p (operands[1], operands[4], operands[2])
   && !s390_overlap_p (operands[0], operands[1],
                       INTVAL (operands[2]) + INTVAL (operands[5]))
   && INTVAL (operands[2]) + INTVAL (operands[5]) <= 256))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_22 (insn, operands);

            case CONST_INT:
              if (XWINT (x12, 0) != 0L)
                return NULL;
              operands[1] = x14;
              x22 = XEXP (x18, 1);
              if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              operands[2] = x19;
              operands[3] = x21;
              if (!
#line 9021 "../../gcc/config/s390/s390.md"
(s390_offset_p (operands[0], operands[2], operands[1])
   && INTVAL (operands[1]) + INTVAL (operands[3]) <= 256))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_23 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
